﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UFIDA.U9.BC.BaseData;
using UFIDA.U9.CBO.SCM.Warehouse;
using UFSoft.UBF.PL;

namespace UFIDA.U9.Cust.KuSi.zhangky.BPSVPlug.CreateDocByQuickTransIn
{
    public partial class CreateDocByQuickTransInPlug : UFSoft.UBF.Service.BPSVExtendBase
    {
        public override void AfterDo(object bp, ref object result)
        {
            //货位整理
            #region 获取相关强类型数据                               

            int TransferInType = 0;//一步式或者二步式
            Hashtable hashtable = new Hashtable();

            UFIDA.U9.BC.QuickTransIn.CreateDocByQuickTransIn strongBP = bp as UFIDA.U9.BC.QuickTransIn.CreateDocByQuickTransIn;
            if (strongBP == null)
                return;
            foreach (var createDocParamDTOData in strongBP.ParamInList)
            {
                if (createDocParamDTOData.TransferInType == 0)//一步式，直接生成调入单，插入库位 
                {
                    TransferInType = 0;
                }
                else if (createDocParamDTOData.TransferInType == 1) //二步式，生成的是调出单，删除库位 
                {
                    TransferInType = 1;
                }
                else 
                {
                    TransferInType = 2;//无效类型
                }
                foreach (var createDocDataDTOData in createDocParamDTOData.Datas)
                {
                    foreach (var item2 in createDocDataDTOData.BarCodes)
                    {
                        long binid = 0;
                        string bincode = "";
                        string binname = "";
                        UFIDA.U9.CBO.SCM.Bin.Bin bin = UFIDA.U9.CBO.SCM.Bin.Bin.Finder.FindByID(item2.TransInBin);
                        if (bin != null)
                        {
                            binid = bin.ID;
                            bincode = bin.Code;
                            binname = bin.Name;
                        }
                        BinWhMsg binWhMsg = new BinWhMsg();
                        binWhMsg.binid = binid;
                        binWhMsg.bincode = bincode;
                        binWhMsg.binname = binname;
                        hashtable.Add(item2.BarCode, binWhMsg);
                    }
                }
            }

            List<UFIDA.U9.BC.QuickTransIn.RtnDTOData> rtnDTODatas = result as List<UFIDA.U9.BC.QuickTransIn.RtnDTOData>;
            if (rtnDTODatas == null) 
            {
                return;
            }
            foreach (var rtnDTOData in rtnDTODatas)
            {
                if (TransferInType == 0)
                {
                    UFIDA.U9.InvDoc.TransferIn.TransInLine transInLine = UFIDA.U9.InvDoc.TransferIn.TransInLine.Finder.FindByID(rtnDTOData.DocLineID);
                    if (transInLine==null) 
                    {
                        continue;
                    }
                    foreach (var hsKey in hashtable.Keys)
                    {
                        if (hsKey.Equals(rtnDTOData.BarCode))
                        {
                            BinWhMsg binWhMsg = hashtable[hsKey] as BinWhMsg;
                            UpdateBarCode.Update(rtnDTOData.DocLineID, "UFIDA.U9.InvDoc.TransferIn.TransInLine","", binWhMsg.binid, binWhMsg.bincode, binWhMsg.binname, transInLine.TransInWh.ID, transInLine.TransInWh.Code, transInLine.TransInWh.Name);
                        }
                    }
                }
                else if (TransferInType == 1) 
                {
                    ClearBinWh.Clear(rtnDTOData.DocLineID, "UFIDA.U9.InvDoc.TransferOut.TransOutLine", rtnDTOData.BarCode);
                }
            }
            #endregion

        }

        public override void BeforeDo(object bp)
        {
            BC.QuickTransIn.CreateDocByQuickTransIn bpObj = (BC.QuickTransIn.CreateDocByQuickTransIn)bp;

            foreach (var paramDTO in bpObj.ParamInList)
            {
                Warehouse outWh = Warehouse.Finder.FindByID(paramDTO.OutWh);
                if (outWh != null)
                {
                    foreach (var docDTO in paramDTO.Datas)
                    {
                        foreach (var barCodeDTO in docDTO.BarCodes)
                        {
                            BarCode barCode = BarCode.Finder.Find("Code=@Code",
                                new OqlParam[]
                                {
                                    new OqlParam(barCodeDTO.BarCode)
                                });

                            if (barCode != null)
                            {
                                if (barCode["Cust4Whid"] == null)
                                {
                                    throw new Exception(string.Format("条码{0}当前存储地点为空，不允许进行调拨", barCode.Code));
                                }

                                Warehouse currentWh = Warehouse.Finder.FindByID(barCode["Cust4Whid"]);
                                if (currentWh == null)
                                {
                                    throw new Exception(string.Format("条码{0}当前存储地点为空，不允许进行调拨", barCode.Code));
                                }

                                if (outWh.ID != currentWh.ID)
                                {
                                    throw new Exception(string.Format("调出存储地点{0}与条码{1}当前存储地点{2}不一致，不允许进行调拨", outWh.Name, barCode.Code, currentWh.Name));
                                }
                            }
                        }
                    }
                }
                else
                {
                    throw new Exception("调出仓库不能为空");
                }

            }
        }

        class BinWhMsg
        {
            public long binid { get; set; }
            public string bincode { get; set; }
            public string binname { get; set; }
           
        }
    }
}
