﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UFIDA.U9.BC.RcvComfirmSV;
using UFSoft.UBF.PL.Engine.Cache;

namespace UFIDA.U9.Cust.KuSi.zhangky.BPSVPlug.RcvComfirmByLineSV
{
    public partial class RcvComfirmByLineSVPlug : UFSoft.UBF.Service.BPSVExtendBase
    {
        private List<string> listBarcode;

        public override void AfterDo(object bp, ref object result)
        {
            //采购退货+收货确认入库
            #region 获取相关强类型数据                               

            UFIDA.U9.BC.RcvComfirmSV.RcvComfirmByLineSV strongBP = bp as UFIDA.U9.BC.RcvComfirmSV.RcvComfirmByLineSV;
            if (strongBP == null)
                return;
            PLCacheManager.DataCache.FlushCache();
            PLCacheManager.ObjectCache.FlushCache();
            foreach (RcvLineDTOData rcvLineDTOData in strongBP.ParamInList)
            {
                foreach (RcvLineBarCodeDTOData rcvLineBarCodeDTOData in rcvLineDTOData.DocLines)
                {
                    foreach (var barcodeTmp in listBarcode)
                    {
                        string barcode = barcodeTmp.Split(new string[] { "%%%" }, StringSplitOptions.None)[0];
                        UFIDA.U9.PM.Rcv.RcvLine rcvLine = UFIDA.U9.PM.Rcv.RcvLine.Finder.FindByID(rcvLineBarCodeDTOData.DocLineID);
                        if (rcvLine == null)
                        {
                            continue;
                        }
                        UFIDA.U9.PM.Pub.RcvDocType rcvDocType = UFIDA.U9.PM.Pub.RcvDocType.Finder.FindByID(rcvLine.Receivement.DocType.ID);
                        if (rcvDocType == null)
                        {
                            continue;
                        }
                        if (rcvDocType.ReceivementType.Value == CBO.SCM.Enums.ReceivementTypeEnum.PurReturn.Value)//采购退货
                        {
                            ClearBinWh.Clear(rcvLineBarCodeDTOData.DocLineID, "UFIDA.U9.PM.Rcv.RcvLine", barcode);
                        }
                        else if (rcvDocType.ReceivementType.Value == CBO.SCM.Enums.ReceivementTypeEnum.RCV.Value) //收货确认入库
                        {
                            long binid = long.Parse(barcodeTmp.Split(new string[] { "%%%" }, StringSplitOptions.None)[1]);

                            UFIDA.U9.CBO.SCM.Bin.Bin bin = UFIDA.U9.CBO.SCM.Bin.Bin.Finder.FindByID(binid);
                            if (bin == null)
                            {
                                continue;
                            }
                            UpdateBarCode.Update(rcvLineBarCodeDTOData.DocLineID, "UFIDA.U9.PM.Rcv.RcvLine", barcode, bin.ID, bin.Code, bin.Name, rcvLine.Wh.ID, rcvLine.Wh.Code, rcvLine.Wh.Name);
                        }
                    }
                }
            }
            listBarcode.Clear();
            #endregion
        }

        public override void BeforeDo(object bp)
        {
            #region 获取相关强类型数据                               

            UFIDA.U9.BC.RcvComfirmSV.RcvComfirmByLineSV strongBP = bp as UFIDA.U9.BC.RcvComfirmSV.RcvComfirmByLineSV;
            if (strongBP == null)
                return;
            PLCacheManager.DataCache.FlushCache();
            PLCacheManager.ObjectCache.FlushCache();
            listBarcode =new List<string>();
            foreach (RcvLineDTOData rcvLineDTOData in strongBP.ParamInList)
            {
                foreach (RcvLineBarCodeDTOData rcvLineBarCodeDTOData in rcvLineDTOData.DocLines)
                {
                    foreach (var barCodeUseQtyDTOData in rcvLineBarCodeDTOData.BarCodeList)
                    {
                        listBarcode.Add(barCodeUseQtyDTOData.BarCode);
                        UFIDA.U9.PM.Rcv.RcvLine rcvLine = UFIDA.U9.PM.Rcv.RcvLine.Finder.FindByID(rcvLineBarCodeDTOData.DocLineID);
                        if (rcvLine == null)
                        {
                            continue;
                        }
                        UFIDA.U9.PM.Pub.RcvDocType rcvDocType = UFIDA.U9.PM.Pub.RcvDocType.Finder.FindByID(rcvLine.Receivement.DocType.ID);
                        if (rcvDocType == null)
                        {
                            continue;
                        }
                        if (rcvDocType.ReceivementType.Value == CBO.SCM.Enums.ReceivementTypeEnum.RCV.Value) //收货确认入库
                        {
                            barCodeUseQtyDTOData.BarCode = barCodeUseQtyDTOData.BarCode.Split(new string[] { "%%%" }, StringSplitOptions.None)[0];
                        }
                    }
                }
            }
            #endregion
        }
    }
}
