﻿namespace UFIDA.U9.Cust.Kusi.CJJ.RestApi
{
	using System;
	using System.Collections.Generic;
	using System.Text; 
	using UFSoft.UBF.AopFrame;
	using UFSoft.UBF.Business;
	using UFSoft.UBF.PL;
	using UFSoft.UBF.UQL.XMD;
	using UFSoft.UBF.Util.Context;

	/// <summary>
	/// AnalyzeDocBarCodeSV partial 
	/// </summary>	
	public partial class AnalyzeDocBarCodeSV 
	{	
		internal BaseStrategy Select()
		{
			return new AnalyzeDocBarCodeSVImpementStrategy();	
		}		
	}
	
	#region  implement strategy	
	/// <summary>
	/// Impement Implement
	/// 
	/// </summary>	
	internal partial class AnalyzeDocBarCodeSVImpementStrategy : BaseStrategy
	{
		public AnalyzeDocBarCodeSVImpementStrategy() { }

		public override object Do(object obj)
		{						
			AnalyzeDocBarCodeSV bpObj = (AnalyzeDocBarCodeSV)obj;

			List<BarCodeanalyzeResultDTOData> result = new List<BarCodeanalyzeResultDTOData>();
			foreach(var dto in bpObj.BarCodes)
			{
				BC.BaseData.BarCode barCode = BC.BaseData.BarCode.Finder.Find("Code=@BarCode",
					new UFSoft.UBF.PL.OqlParam[]
					{
						new UFSoft.UBF.PL.OqlParam(dto.BarCode)
					});
				
				if (barCode == null)
				{
					throw new Exception(String.Format("条码：{0} 不存在", dto.BarCode));
				}

				if (barCode.BarCodeType != UFIDA.U9.BC.Common.BarCodeTypeEnum.DocBarCode)
				{
					throw new Exception(String.Format("条码：{0}不是单据头条码", dto.BarCode));
				}

                

                if (barCode.CreateEntity != null)
				{
					BusinessEntity entity = new BusinessEntity.EntityKey(barCode.CreateEntity.EntityID, barCode.CreateEntity.EntityType).GetEntity();
					if (entity != null)
					{
						result.Add(new BarCodeanalyzeResultDTOData()
						{
							EntityID = barCode.CreateEntity.EntityID,
							EntityType = barCode.CreateEntity.EntityType,
							BarCode = barCode.Code,
							DocNo = entity.GetValue("DocNo").ToString(),
							FlowID = entity.GetValue("WorkFlowID").ToString(),
							AttachmentInfos = GetAttachmentInfoDTOs(barCode.CreateEntity.EntityID, barCode.CreateEntity.EntityType)
						});
					}
				}
            }

			return result;
		}
		
		private List<AttachmentInfoDTOData> GetAttachmentInfoDTOs(long id, string entityType)
		{
			List<AttachmentInfoDTOData> result = new List<AttachmentInfoDTOData>();

			var attachments = new ISV.MobileApprovalSV.GetAttachmentFileListService()
			{
				Data = new ISV.CommonServiceSV.CommonParamData()
				{
					Condition = new List<ISV.CommonServiceSV.CommonVOData>()
					{
						new ISV.CommonServiceSV.CommonVOData()
						{
							Value1 = id.ToString(),
							ItemName = "entityid"
						},
						new ISV.CommonServiceSV.CommonVOData()
						{
							Value1 = entityType,
							ItemName = "entitytype"
                        }
					}
				}
			}.Do();

			foreach (var attachment in attachments.RecordList)
			{
				result.Add(new AttachmentInfoDTOData()
				{
					ID = attachment.ID,
					FileName = attachment.FileName,
					FileURL = attachment.FileURL
				});

            }

            return result;
        }
    }

	#endregion
	
	
}