﻿namespace UFIDA.U9.Cust.Kusi.CJJ.RestApi
{
	using System;
	using System.Collections.Generic;
	using System.Text;
    using UFIDA.U9.Base.Doc;
    using UFSoft.UBF.AopFrame;
    using UFSoft.UBF.Business;
    using UFSoft.UBF.Util.Context;

    /// <summary>
    /// CreateDocByQuickTransInWithPackage partial 
    /// </summary>	
	public partial class CreateDocByQuickTransInWithPackage 
	{	
		internal BaseStrategy Select()
		{
			return new CreateDocByQuickTransInWithPackageImpementStrategy();	
		}		
	}
	
	#region  implement strategy	
	/// <summary>
	/// Impement Implement
	/// 
	/// </summary>	
	internal partial class CreateDocByQuickTransInWithPackageImpementStrategy : BaseStrategy
	{
		public CreateDocByQuickTransInWithPackageImpementStrategy() { }

		public override object Do(object obj)
		{						
			CreateDocByQuickTransInWithPackage bpObj = (CreateDocByQuickTransInWithPackage)obj;
			if (bpObj.ParamInList == null || bpObj.ParamInList.Count == 0)
			{
				throw new Exception("传入生单数据为空，请检查！");
			}
            List<BC.QuickTransIn.CreateDocParamDTOData> paramInList = bpObj.ParamInList;
            List<BC.QuickTransIn.RtnDTOData> list = new List<BC.QuickTransIn.RtnDTOData>();
            foreach (BC.QuickTransIn.CreateDocParamDTOData createDocParamDTOData in paramInList)
            {
                this.CheckParams(createDocParamDTOData);
				CBO.SCM.Warehouse.Warehouse inWh = CBO.SCM.Warehouse.Warehouse.Finder.FindByID(createDocParamDTOData.InWh);
				CBO.SCM.Warehouse.Warehouse outWh = CBO.SCM.Warehouse.Warehouse.Finder.FindByID(createDocParamDTOData.OutWh);
                long docType = this.GetDocType(createDocParamDTOData.DocTypeID);
                List<BC.QuickTransIn.CreateDocDataDTOData> datas = createDocParamDTOData.Datas;
                if (createDocParamDTOData.TransferInType == 1)
                {
                    this.CreateTransIn_TwoStepTransIn(createDocParamDTOData, inWh, outWh, docType, datas, list);
                }
                else
                {
                    this.CreateTransIn_OneStepTransIn(createDocParamDTOData, inWh, outWh, docType, datas, list);
                }
            }

            return list;
        }

        private void CheckParams(BC.QuickTransIn.CreateDocParamDTOData dto)
        {
            if (string.IsNullOrEmpty(dto.InWh))
            {
                throw new Exception("【" + dto.AppKey + "】调入存储地点参数为空，请选择！");
            }
            if (CBO.SCM.Warehouse.Warehouse.Finder.FindByID(dto.InWh) == null)
            {
                throw new Exception("【" + dto.AppKey + "】调入存储地点ID未找到对应实体，请检查数据！");
            }
            if (string.IsNullOrEmpty(dto.OutWh))
            {
                throw new Exception("【" + dto.AppKey + "】调出存储地点参数为空，请重新操作！");
            }
            if (CBO.SCM.Warehouse.Warehouse.Finder.FindByID(dto.OutWh) == null)
            {
                throw new Exception("【" + dto.AppKey + "】调出存储地点ID未找到对应实体，请检查数据！");
            }
            if (dto.Datas == null || dto.Datas.Count == 0)
            {
                throw new Exception("【" + dto.AppKey + "】生单明细信息参数为空，请重新操作！");
            }
        }

        public long GetDocType(string docType)
        {
            long result;
            if (string.IsNullOrEmpty(docType))
            {
                result = -1L;
            }
            else
            {
                try
                {
                    result = Convert.ToInt64(docType);
                }
                catch
                {
                    result = -1L;
                }
            }
            return result;
        }

        private void CreateTransIn_TwoStepTransIn(BC.QuickTransIn.CreateDocParamDTOData dto, CBO.SCM.Warehouse.Warehouse inWh, CBO.SCM.Warehouse.Warehouse outWh, long docTypeID, List<BC.QuickTransIn.CreateDocDataDTOData> dataList, List<BC.QuickTransIn.RtnDTOData> resultList)
        {
            List<InvDoc.TransferIn.TransferOutDTOData> list = new List<InvDoc.TransferIn.TransferOutDTOData>();
            foreach (BC.QuickTransIn.CreateDocDataDTOData docDto in dataList)
            {
                InvDoc.TransferIn.TransferOutDTOData transferOutDTOData = new InvDoc.TransferIn.TransferOutDTOData();
                this.Set_IC_TransferOutDTOData(transferOutDTOData, outWh, inWh, dto, docDto, docTypeID);
                list.Add(transferOutDTOData);
            }

            List<long> list2 = new InvDoc.TransferOut.Proxy.CreateTransferOutSRVProxy
            {
                TransferOutDOCList = list
            }.Do();
            
            List<InvDoc.TransferOut.TransferOut> list3 = new List<InvDoc.TransferOut.TransferOut>();
            
            if (dto.CreateDocState >= 1)
            {
                using (ISession session = Session.Open())
                {
                    foreach (long num in list2)
                    {
                        InvDoc.TransferOut.TransferOut transferOut = InvDoc.TransferOut.TransferOut.Finder.FindByID(num);
                        if (transferOut != null)
                        {
                            transferOut.Status = InvDoc.TransferOut.Status.Approving;
                            if (transferOut.TransOutDocType.ConfirmType != ConfirmTypeEnum.ApproveFlow)
                            {
                                list3.Add(transferOut);
                            }
                            session.InList(transferOut);
                        }
                    }
                    session.Commit();
                }
            }
            if (dto.CreateDocState >= 2)
            {
                using (ISession session = Session.Open())
                {
                    foreach (InvDoc.TransferOut.TransferOut transferOut in list3)
                    {
                        transferOut.Status = InvDoc.TransferOut.Status.Approved;
                        session.InList(transferOut);
                    }
                    session.Commit();
                }
            }
            resultList.AddRange(this.CreateBarCodeUsed_TransOut(list2, dataList));
        }

        private void Set_IC_TransferOutDTOData(InvDoc.TransferIn.TransferOutDTOData transOutDTO, CBO.SCM.Warehouse.Warehouse outWh, CBO.SCM.Warehouse.Warehouse inWh, BC.QuickTransIn.CreateDocParamDTOData dto, BC.QuickTransIn.CreateDocDataDTOData docDto, long docTypeID)
        {
            transOutDTO.Org = outWh.OrgKey.ID;
            transOutDTO.HeadMemo = "快速调拨App生成";
            transOutDTO.DocDate = Base.Context.OperationDate;
            transOutDTO.TransferDirection = dto.TransferDirection;
            transOutDTO.TransferType = ((inWh.OrgKey != outWh.OrgKey) ? 0 : 1);
            transOutDTO.DocType = this.GetTransOutDocType(docTypeID);
            transOutDTO.TransOutOrg = outWh.OrgKey.ID;
            transOutDTO.TransOutWh = outWh.Key.ID;
            CBO.Pub.Controller.CommonArchiveDataDTOData ownerOrg = this.GetOwnerOrg(outWh.Org, docDto.OwnerOrgCode);
            if (ownerOrg != null)
            {
                transOutDTO.TransOutOwnerOrg = ownerOrg.ID;
            }
            if (transOutDTO.TransOutOrg == Base.Context.LoginOrg.ID)
            {
                CBO.HR.Operator.Operators currentDepotOperators = CBO.HR.Operator.Operators.GetCurrentDepotOperators();
                if (currentDepotOperators != null)
                {
                    transOutDTO.TransOutWhMan = currentDepotOperators.Key.ID;
                }
            }
            if (docDto.TransOutDataDTO != null)
            {
                transOutDTO.TransOutDept = docDto.TransOutDataDTO.TransOutDept;
                transOutDTO.TransOutCustInfo = new CBO.SCM.Customer.CustomerMISCInfoData();
                transOutDTO.TransOutCustInfo.Customer = docDto.TransOutDataDTO.TransOutCustinfo;
                transOutDTO.TransOutSuppInfo = new CBO.SCM.Supplier.SupplierMISCInfoData();
                transOutDTO.TransOutSuppInfo.Supplier = this.GetSupplierByCode(outWh.Org.ID, docDto.TransOutDataDTO.TransOutSupplierCode);
                if (docDto.TransOutDataDTO.IsVMI && transOutDTO.TransOutSuppInfo.Supplier <= 0L)
                {
                    throw new Exception("调出，其中行是VMI业务，不允许供应商信息为空");
                }
                transOutDTO.TransOutSite = docDto.TransOutDataDTO.TransOutSite;
                transOutDTO.TransOutIsVMI = docDto.TransOutDataDTO.IsVMI;
                transOutDTO.TransOutBin = this.Set_TransferOutDTOData_Bins(docDto.TransOutDataDTO.OutBinDataDTOs);
            }
            Base.UOM.UOM uom = this.GetinvUOMByCode(docDto.InvUOMCode);
            if (uom != null)
            {
                transOutDTO.StoreUOM = uom.ID;
                transOutDTO.StoreBaseUOM = ((uom.BaseUOMKey != null) ? uom.BaseUOMKey.ID : -1L);
            }
            transOutDTO.StoreUOMQty = Convert.ToDecimal(docDto.Qty);
            transOutDTO.StorageType = 4;
            if (outWh.IsLot)
            {
                CBO.SCM.PropertyTypes.LotInfoData lotInfo = BC.BCRestSV.Public.BCRestSVHelper.GetLotInfo(outWh.OrgKey.ID, docDto.ItemCode, docDto.LotCode);
                if (lotInfo != null)
                {
                    transOutDTO.LotInfo = lotInfo;
                }
            }
            CBO.Pub.Controller.CommonArchiveDataDTOData projectInfo = BC.BCRestSV.Public.BCRestSVHelper.GetProjectInfo(outWh.OrgKey.ID, docDto.ProjectCode);
            if (projectInfo != null)
            {
                transOutDTO.TransOutProject = projectInfo.ID;
            }
            CBO.Pub.Controller.CommonArchiveDataDTOData seibanInfo = BC.BCRestSV.Public.BCRestSVHelper.GetSeibanInfo(outWh.OrgKey.ID, docDto.SeibanCode);
            if (seibanInfo != null && seibanInfo.ID > 0L)
            {
                transOutDTO.TransOutSeiban = new CBO.SCM.Seiban.SeibanMasterData();
                transOutDTO.TransOutSeiban.ID = seibanInfo.ID;
                transOutDTO.TransOutSeibanCode = seibanInfo.Code;
            }
            transOutDTO.Manufacturer = BC.BCRestSV.Public.BCRestSVHelper.GetManufacturerInfo(outWh.OrgKey.ID, docDto.SupplierCode);
            transOutDTO.ItemInfo = BC.BCRestSV.Public.BCRestSVHelper.GetItemInfo(Base.Context.LoginOrg.Code, docDto.ItemCode, docDto.Grade, docDto.Potency);
            transOutDTO.LinePublicFlexFields = new Base.FlexField.DescFlexField.PubDescFlexSegmentsData();
            transOutDTO.TransInOrg = inWh.OrgKey.ID;
            transOutDTO.TransInWh = inWh.Key.ID;
            CBO.Pub.Controller.CommonArchiveDataDTOData ownerOrg2 = this.GetOwnerOrg(inWh.Org, docDto.OwnerOrgCode);
            if (ownerOrg != null)
            {
                transOutDTO.TransInOwnerOrg = ownerOrg2.ID;
            }
            if (transOutDTO.TransInOrg == Base.Context.LoginOrg.ID)
            {
                CBO.HR.Operator.Operators currentDepotOperators = CBO.HR.Operator.Operators.GetCurrentDepotOperators();
                if (currentDepotOperators != null)
                {
                    transOutDTO.TransInWhMan = currentDepotOperators.Key.ID;
                }
            }
            if (docDto.TransInDataDTO != null)
            {
                transOutDTO.TransInDept = docDto.TransInDataDTO.TransInDept;
                transOutDTO.TransInCustInfo = new CBO.SCM.Customer.CustomerMISCInfoData();
                transOutDTO.TransInCustInfo.Customer = docDto.TransInDataDTO.TransInCustInfo;
                transOutDTO.TransInSuppInfo = new CBO.SCM.Supplier.SupplierMISCInfoData();
                transOutDTO.TransInSuppInfo.Supplier = this.GetSupplierByCode(inWh.Org.ID, docDto.TransInDataDTO.TransInSupplierCode);
                if (docDto.TransInDataDTO.IsVMI && transOutDTO.TransInSuppInfo.Supplier <= 0L)
                {
                    throw new Exception("调入，其中行是VMI业务，不允许供应商信息为空");
                }
                transOutDTO.TransInSite = docDto.TransInDataDTO.TransInSite;
                transOutDTO.TransInIsVMI = docDto.TransInDataDTO.IsVMI;
                transOutDTO.TransInBin = this.Set_TransferOutDTOData_Bins(docDto.TransInDataDTO.InBinDataDTOs);
            }
            if (inWh.IsLot && transOutDTO.LotInfo == null)
            {
                transOutDTO.LotInfo = BC.BCRestSV.Public.BCRestSVHelper.GetLotInfo(inWh.OrgKey.ID, docDto.ItemCode, docDto.LotCode);
            }
            CBO.Pub.Controller.CommonArchiveDataDTOData projectInfo2 = BC.BCRestSV.Public.BCRestSVHelper.GetProjectInfo(inWh.OrgKey.ID, docDto.ProjectCode);
            if (projectInfo2 != null)
            {
                transOutDTO.TransInProject = projectInfo2.ID;
            }
            CBO.Pub.Controller.CommonArchiveDataDTOData seibanInfo2 = BC.BCRestSV.Public.BCRestSVHelper.GetSeibanInfo(inWh.OrgKey.ID, docDto.SeibanCode);
            if (seibanInfo2 != null && seibanInfo2.ID > 0L)
            {
                transOutDTO.TransInSeiban = new CBO.SCM.Seiban.SeibanMasterData();
                transOutDTO.TransInSeiban.ID = seibanInfo2.ID;
                transOutDTO.TransInSeibanCode = seibanInfo2.Code;
            }
            transOutDTO.SublinePublicFlexFields = new Base.FlexField.DescFlexField.PubDescFlexSegmentsData();
            if (uom != null)
            {
                transOutDTO.TransInSU = uom.ID;
            }
            transOutDTO.TransInSUQty = Convert.ToDecimal(docDto.Qty);
        }

        private InvDoc.TransferOut.TransOutDocTypeData GetTransOutDocType(long docTypeID)
        {
            InvDoc.TransferOut.TransOutDocType transOutDocType = InvDoc.TransferOut.TransOutDocType.Finder.FindByID(docTypeID);
            InvDoc.TransferOut.TransOutDocTypeData result;
            if (transOutDocType == null)
            {
                result = null;
            }
            else
            {
                //InvDoc.TransferOut.TransOutDocTypeData transOutDocTypeData = new InvDoc.TransferOut.TransOutDocTypeData();
                //transOutDocTypeData = transOutDocType.ToEntityData();
                result = transOutDocType.ToEntityData();
            }
            return result;
        }

        public CBO.Pub.Controller.CommonArchiveDataDTOData GetOwnerOrg(Base.Organization.Organization org, string orgCode)
        {
            CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData = new CBO.Pub.Controller.CommonArchiveDataDTOData();
            if (org != null && org.Code != orgCode && orgCode != "")
            {
                org = Base.Organization.Organization.FindByCode(orgCode);
            }
            if (org == null)
            {
                org = Base.Context.LoginOrg;
            }
            commonArchiveDataDTOData.ID = org.ID;
            commonArchiveDataDTOData.Code = org.Code;
            commonArchiveDataDTOData.Name = org.Name;

            return commonArchiveDataDTOData;
        }

        private long GetSupplierByCode(long org, string supplierCode)
        {
            long result;
            if (string.IsNullOrWhiteSpace(supplierCode))
            {
                result = 0L;
            }
            else
            {
                string text = "QuickTransIn_Supplier_IsSend" + org.ToString();
                string text2 = "QuickTransIn_Supplier_Entity" + org.ToString() + supplierCode;
                if (UFSoft.UBF.Services.Session.ServiceSession.ThreadStorage[text2] != null)
                {
                    result = (long)UFSoft.UBF.Services.Session.ServiceSession.ThreadStorage[text2];
                }
                else
                {
                    bool flag;
                    if (UFSoft.UBF.Services.Session.ServiceSession.ThreadStorage[text] != null)
                    {
                        flag = (bool)UFSoft.UBF.Services.Session.ServiceSession.ThreadStorage[text];
                    }
                    else
                    {
                        flag = CBO.Pub.Controller.BaseObject.EntitytIsSend("UFIDA.U9.CBO.SCM.ProjectTask.Project");
                        UFSoft.UBF.Services.Session.ServiceSession.ThreadStorage[text] = flag;
                    }
                    if (flag)
                    {
                        UFSoft.UBF.PL.OqlParamList oqlParamList = new UFSoft.UBF.PL.OqlParamList();
                        oqlParamList.Add(new UFSoft.UBF.PL.OqlParam(org));
                        oqlParamList.Add(new UFSoft.UBF.PL.OqlParam(supplierCode));
                        CBO.SCM.Supplier.Supplier supplier = CBO.SCM.Supplier.Supplier.Finder.Find("Org=@Org and Code=@Code", oqlParamList.ToArray());
                        if (supplier != null)
                        {
                            UFSoft.UBF.Services.Session.ServiceSession.ThreadStorage[text2] = supplier.ID;
                            result = supplier.ID;
                        }
                        else
                        {
                            UFSoft.UBF.Services.Session.ServiceSession.ThreadStorage[text2] = 0;
                            result = 0L;
                        }
                    }
                    else
                    {
                        UFSoft.UBF.PL.OqlParamList oqlParamList = new UFSoft.UBF.PL.OqlParamList();
                        oqlParamList.Add(new UFSoft.UBF.PL.OqlParam(supplierCode));
                        CBO.SCM.Supplier.Supplier supplier = CBO.SCM.Supplier.Supplier.Finder.Find("Code=@Code", oqlParamList.ToArray());
                        if (supplier != null)
                        {
                            UFSoft.UBF.Services.Session.ServiceSession.ThreadStorage[text2] = supplier.ID;
                            result = supplier.ID;
                        }
                        else
                        {
                            UFSoft.UBF.Services.Session.ServiceSession.ThreadStorage[text2] = 0;
                            result = 0L;
                        }
                    }
                }
            }
            return result;
        }

        private List<InvDoc.TransferIn.TransferOutBinDTOData> Set_TransferOutDTOData_Bins(List<BC.QuickTransIn.DocBinDataDTOData> OutBinDataDTOs)
        {
            List<InvDoc.TransferIn.TransferOutBinDTOData> list = new List<InvDoc.TransferIn.TransferOutBinDTOData>();
            foreach (BC.QuickTransIn.DocBinDataDTOData docBinDataDTOData in OutBinDataDTOs)
            {
                list.Add(new InvDoc.TransferIn.TransferOutBinDTOData
                {
                    BinInfo = this.GetBinInfoData(docBinDataDTOData),
                    StoreUOMQty = docBinDataDTOData.Qty
                });
            }
            return list;
        }

        private CBO.SCM.Bin.BinInfoData GetBinInfoData(BC.QuickTransIn.DocBinDataDTOData binData)
        {
            return new CBO.SCM.Bin.BinInfoData
            {
                Bin = binData.BinID,
                Code = binData.BinCode,
                Name = binData.BinName
            };
        }

        private Base.UOM.UOM GetinvUOMByCode(string code)
        {
            UFSoft.UBF.PL.OqlParamList oqlParamList = new UFSoft.UBF.PL.OqlParamList();
            oqlParamList.Add(new UFSoft.UBF.PL.OqlParam(code));
            return Base.UOM.UOM.Finder.Find("Code=@Code", oqlParamList.ToArray());
        }

        private List<BC.QuickTransIn.RtnDTOData> CreateBarCodeUsed_TransOut(List<long> reDTOList, List<BC.QuickTransIn.CreateDocDataDTOData> dataList)
        {
            List<BC.CalcData.CreateBarCodeUsedInDTO> list = new List<BC.CalcData.CreateBarCodeUsedInDTO>();
            List<BC.QuickTransIn.RtnDTOData> list2 = new List<BC.QuickTransIn.RtnDTOData>();
            foreach (long num in reDTOList)
            {
                InvDoc.TransferOut.TransferOut transferOut = InvDoc.TransferOut.TransferOut.Finder.FindByID(num);
                foreach (InvDoc.TransferOut.TransOutLine transOutLine in transferOut.TransOutLines)
                {
                    List<BC.QuickTransIn.CreateDocBCDataDTOData> barCodes_TransOut = this.GetBarCodes_TransOut(transOutLine, dataList);
                    foreach (BC.QuickTransIn.CreateDocBCDataDTOData createDocBCDataDTOData in barCodes_TransOut)
                    {
                        BC.CalcData.CreateBarCodeUsedInDTO createBarCodeUsedInDTO = new BC.CalcData.CreateBarCodeUsedInDTO();
                        createBarCodeUsedInDTO.BarCode = createDocBCDataDTOData.BarCode;
                        createBarCodeUsedInDTO.CurQty = createDocBCDataDTOData.WhQty;
                        createBarCodeUsedInDTO.IsUpdateWh = false;
                        createBarCodeUsedInDTO.Direct = BC.Common.DirectEnum.Undefine;
                        createBarCodeUsedInDTO.DocOrg = transferOut.Org.Key;
                        createBarCodeUsedInDTO.Doc = new Base.PropertyTypes.BizEntityKey(transferOut.Key.ID, transferOut.Key.EntityType);
                        createBarCodeUsedInDTO.DocLine = new Base.PropertyTypes.BizEntityKey(transOutLine.Key.ID, transOutLine.Key.EntityType);
                        createBarCodeUsedInDTO.DocNo = transferOut.DocNo;
                        createBarCodeUsedInDTO.DocLineNo = transOutLine.DocLineNo.ToString();
                        if (transOutLine.ItemInfo != null)
                        {
                            createBarCodeUsedInDTO.Item = transOutLine.ItemInfo.ItemID.Key;
                            createBarCodeUsedInDTO.ItemCode = transOutLine.ItemInfo.ItemCode;
                            createBarCodeUsedInDTO.ItemName = transOutLine.ItemInfo.ItemName;
                        }
                        list.Add(createBarCodeUsedInDTO);
                        list2.Add(new BC.QuickTransIn.RtnDTOData
                        {
                            IsSuccess = true,
                            BarCode = createDocBCDataDTOData.BarCode,
                            DocNo = transferOut.DocNo,
                            DocID = transferOut.Key.ID,
                            DocType = transferOut.Key.EntityType,
                            LineNum = transOutLine.DocLineNo.ToString(),
                            DocLineID = transOutLine.Key.ID,
                            DocLineType = transOutLine.Key.EntityType
                        });
                    }
                }
            }
            
            new BC.CalcData.CreateBarCodeUsedSV
            {
                App = 11,
                CreateBCUsedInParams = list
            }.Do();
            return list2;
        }

        private List<BC.QuickTransIn.CreateDocBCDataDTOData> GetBarCodes_TransOut(InvDoc.TransferOut.TransOutLine line, List<BC.QuickTransIn.CreateDocDataDTOData> dataList)
        {
            foreach (BC.QuickTransIn.CreateDocDataDTOData createDocDataDTOData in dataList)
            {
                if (!(line.ItemInfo == null))
                {
                    if (createDocDataDTOData.ItemCode == line.ItemInfo.ItemCode && ((line.TransOutWh.IsLot && line.LotInfo != null && createDocDataDTOData.LotCode == line.LotInfo.LotCode) || !line.TransOutWh.IsLot) && ((line.ProjectKey != null && createDocDataDTOData.ProjectCode == line.Project.Code) || line.ProjectKey == null) && ((line.Seiban != null && createDocDataDTOData.SeibanCode == line.Seiban.SeibanNO) || line.Seiban == null) && ((line.ManufacturerInfo != null && createDocDataDTOData.SupplierCode == line.ManufacturerInfo.Code) || line.ManufacturerInfo == null) && ((line.ItemInfo != null && createDocDataDTOData.Grade == line.ItemInfo.ItemGrade.Value) || line.ItemInfo == null) && ((line.ItemInfo != null && createDocDataDTOData.Potency == line.ItemInfo.ItemPotency.Value) || line.ItemInfo == null))
                    {
                        return createDocDataDTOData.BarCodes;
                    }
                }
            }
            return new List<BC.QuickTransIn.CreateDocBCDataDTOData>();
        }

        private void CreateTransIn_OneStepTransIn(BC.QuickTransIn.CreateDocParamDTOData dto, CBO.SCM.Warehouse.Warehouse inWh, CBO.SCM.Warehouse.Warehouse outWh, long docTypeID, List<BC.QuickTransIn.CreateDocDataDTOData> dataList, List<BC.QuickTransIn.RtnDTOData> resultList)
        {
            ISV.TransferInISV.IC_TransferInDTOData ic_TransferInDTOData = new ISV.TransferInISV.IC_TransferInDTOData();
            this.Set_IC_TransferInDTOData(ic_TransferInDTOData, inWh, outWh, docTypeID, dto);
            foreach (BC.QuickTransIn.CreateDocDataDTOData docDto in dataList)
            {
                ISV.TransferInISV.IC_TransInLineDTOData ic_TransInLineDTOData = new ISV.TransferInISV.IC_TransInLineDTOData();
                this.Set_IC_TransInLineDTOData(ic_TransInLineDTOData, inWh, docDto, dto);

                ISV.TransferInISV.IC_TransInSubLineDTOData ic_TransInSubLineDTOData = new ISV.TransferInISV.IC_TransInSubLineDTOData();
                this.Set_IC_TransInSubLineDTOData(ic_TransInSubLineDTOData, outWh, docDto, dto);

                ic_TransInLineDTOData.TransInSubLines.Add(ic_TransInSubLineDTOData);
                ic_TransferInDTOData.TransInLines.Add(ic_TransInLineDTOData);
            }
            List<CBO.Pub.Controller.CommonArchiveDataDTOData> list = new ISV.TransferInISV.Proxy.CommonCreateTransferInSVProxy
            {
                TransferInDTOList = new List<ISV.TransferInISV.IC_TransferInDTOData>()
                {
                    ic_TransferInDTOData
                }
            }.Do();
            List<CBO.Pub.Controller.CommonArchiveDataDTOData> list2 = new List<CBO.Pub.Controller.CommonArchiveDataDTOData>();
            if (dto.CreateDocState >= 1)
            {
                if (!dto.IsCreateOpenDoc)
                {
                    new ISV.TransferInISV.Proxy.TransferInBatchCommitSRVProxy
                    {
                        DocList = list
                    }.Do();
                    foreach (CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData in list)
                    {
                        InvDoc.TransferIn.TransferIn transferIn = InvDoc.TransferIn.TransferIn.Finder.FindByID(commonArchiveDataDTOData.ID);
                        if (transferIn != null)
                        {
                            if (transferIn.TransInDocType.ConfirmType != ConfirmTypeEnum.ApproveFlow)
                            {
                                list2.Add(commonArchiveDataDTOData);
                            }
                        }
                    }
                }
            }
            if (dto.CreateDocState >= 2)
            {
                new ISV.TransferInISV.Proxy.TransferInBatchApproveSRVProxy
                {
                    DocList = list2
                }.Do();
            }
            resultList.AddRange(this.CreateBarCodeUsed(list, dataList));
        }

        private void Set_IC_TransferInDTOData(ISV.TransferInISV.IC_TransferInDTOData transInDTO, CBO.SCM.Warehouse.Warehouse inWh, CBO.SCM.Warehouse.Warehouse outWh, long docTypeID, BC.QuickTransIn.CreateDocParamDTOData dto)
        {
            transInDTO.ApprovedBy = Base.Context.LoginUser;
            transInDTO.ApprovedOn = DateTime.Now;
            transInDTO.CreatedBy = Base.Context.LoginUser;
            transInDTO.CreatedOn = DateTime.Now;
            transInDTO.ModifiedBy = Base.Context.LoginUser;
            transInDTO.ModifiedOn = DateTime.Now;
            transInDTO.BusinessDate = Base.Context.OperationDate;
            if (!string.IsNullOrEmpty(dto.DocNo))
            {
                transInDTO.DocNo = dto.DocNo;
            }
            transInDTO.DescFlexField = new Base.FlexField.DescFlexField.DescFlexSegmentsData();
            transInDTO.Memo = "快速调拨App创建";
            transInDTO.OnlyUpdateQty = dto.OnlyUpdateQty;
            transInDTO.Org = this.GetOrg(inWh.Org);
            transInDTO.TransferDirection = dto.TransferDirection;
            transInDTO.TransInDocType = this.GetTransInDocType(docTypeID);
            transInDTO.TransferType = ((inWh.OrgKey != outWh.OrgKey) ? 0 : 1);
            transInDTO.TransInLines = new List<ISV.TransferInISV.IC_TransInLineDTOData>();
        }

        public CBO.Pub.Controller.CommonArchiveDataDTOData GetOrg(Base.Organization.Organization org)
        {
            CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData = new CBO.Pub.Controller.CommonArchiveDataDTOData();
            if (org == null)
            {
                org = Base.Context.LoginOrg;
            }
            commonArchiveDataDTOData.ID = org.ID;
            commonArchiveDataDTOData.Code = org.Code;
            commonArchiveDataDTOData.Name = org.Name;
            return commonArchiveDataDTOData;
        }

        private CBO.Pub.Controller.CommonArchiveDataDTOData GetTransInDocType(long docTypeID)
        {
            CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData = new CBO.Pub.Controller.CommonArchiveDataDTOData();
            if (docTypeID > 0L)
            {
                commonArchiveDataDTOData.ID = docTypeID;
            }
            return commonArchiveDataDTOData;
        }

        private void Set_IC_TransInLineDTOData(ISV.TransferInISV.IC_TransInLineDTOData transInLine, CBO.SCM.Warehouse.Warehouse inWh, BC.QuickTransIn.CreateDocDataDTOData docDto, BC.QuickTransIn.CreateDocParamDTOData dto)
        {
            transInLine.CreatedBy = Base.Context.LoginUser;
            transInLine.CreatedOn = DateTime.Now;
            transInLine.ModifiedBy = Base.Context.LoginUser;
            transInLine.ModifiedOn = DateTime.Now;
            transInLine.TransInOwnerOrg = this.GetOwnerOrg(inWh.Org, docDto.OwnerOrgCode);
            transInLine.TransInWh = this.GetWhData(inWh);
            if (inWh.OrgKey.ID == Base.Context.LoginOrg.ID)
            {
                transInLine.TransInWhMan = this.GetWhManData();
            }
            transInLine.ZeroCost = false;
            transInLine.StoreUOM = this.GetinvUOMData(docDto.InvUOMCode);
            transInLine.StoreUOMQty = Convert.ToDecimal(docDto.Qty);
            transInLine.StorageType = 4;
            if (inWh.IsLot)
            {
                transInLine.LotInfo = BC.BCRestSV.Public.BCRestSVHelper.GetLotInfo(inWh.OrgKey.ID, docDto.ItemCode, docDto.LotCode);
            }
            transInLine.Project = BC.BCRestSV.Public.BCRestSVHelper.GetProjectInfo(inWh.OrgKey.ID, docDto.ProjectCode);
            transInLine.Seiban = BC.BCRestSV.Public.BCRestSVHelper.GetSeibanInfo(inWh.OrgKey.ID, docDto.SeibanCode);
            transInLine.ManufacturerInfo = BC.BCRestSV.Public.BCRestSVHelper.GetManufacturerInfo(inWh.OrgKey.ID, docDto.SupplierCode);
            transInLine.ItemInfo = BC.BCRestSV.Public.BCRestSVHelper.GetItemInfo(Base.Context.LoginOrg.Code, docDto.ItemCode, docDto.Grade, docDto.Potency);
            transInLine.IsVMI = false;
            transInLine.DescFlexSegments = new Base.FlexField.DescFlexField.DescFlexSegmentsData();
            if (docDto.TransInDataDTO != null)
            {
                transInLine.TransInDept = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                transInLine.TransInDept.ID = docDto.TransInDataDTO.TransInDept;
                transInLine.TransInCustInfo = new CBO.SCM.Customer.CustomerMISCInfoData();
                transInLine.TransInCustInfo.Customer = docDto.TransInDataDTO.TransInCustInfo;
                transInLine.TransInSuppInfo = new CBO.SCM.Supplier.SupplierMISCInfoData();
                transInLine.TransInSuppInfo.Supplier = this.GetSupplierByCode(inWh.Org.ID, docDto.TransInDataDTO.TransInSupplierCode);
                transInLine.TransInSite = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                transInLine.TransInSite.ID = docDto.TransInDataDTO.TransInSite;
                transInLine.IsVMI = docDto.TransInDataDTO.IsVMI;
                transInLine.ZeroCost = docDto.TransInDataDTO.ZeroCost;
                transInLine.TransInBins = this.Set_IC_TransInBinDTOData(docDto.TransInDataDTO.InBinDataDTOs);
            }
            transInLine.TransInSubLines = new List<ISV.TransferInISV.IC_TransInSubLineDTOData>();
        }

        private CBO.Pub.Controller.CommonArchiveDataDTOData GetWhData(CBO.SCM.Warehouse.Warehouse wh)
        {
            CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData = new CBO.Pub.Controller.CommonArchiveDataDTOData();
            if (wh != null)
            {
                commonArchiveDataDTOData.ID = wh.ID;
                commonArchiveDataDTOData.Code = wh.Code;
                commonArchiveDataDTOData.Name = wh.Name;
            }
            return commonArchiveDataDTOData;
        }

        private CBO.Pub.Controller.CommonArchiveDataDTOData GetWhManData()
        {
            CBO.HR.Operator.Operators currentDepotOperators = CBO.HR.Operator.Operators.GetCurrentDepotOperators();
            CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData = new CBO.Pub.Controller.CommonArchiveDataDTOData();
            if (currentDepotOperators != null)
            {
                commonArchiveDataDTOData.ID = currentDepotOperators.ID;
                commonArchiveDataDTOData.Code = currentDepotOperators.Code;
                commonArchiveDataDTOData.Name = currentDepotOperators.Name;
            }
            return commonArchiveDataDTOData;
        }

        private CBO.Pub.Controller.CommonArchiveDataDTOData GetinvUOMData(string code)
        {
            CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData = new CBO.Pub.Controller.CommonArchiveDataDTOData();
            UFSoft.UBF.PL.OqlParamList oqlParamList = new UFSoft.UBF.PL.OqlParamList();
            oqlParamList.Add(new UFSoft.UBF.PL.OqlParam(code));
            Base.UOM.UOM uom = Base.UOM.UOM.Finder.Find("Code=@Code", oqlParamList.ToArray());
            if (uom != null)
            {
                commonArchiveDataDTOData.ID = uom.ID;
                commonArchiveDataDTOData.Code = uom.Code;
                commonArchiveDataDTOData.Name = uom.Name;
            }
            return commonArchiveDataDTOData;
        }

        private List<ISV.TransferInISV.IC_TransInBinDTOData> Set_IC_TransInBinDTOData(List<BC.QuickTransIn.DocBinDataDTOData> binDataDTOs)
        {
            List<ISV.TransferInISV.IC_TransInBinDTOData> list = new List<ISV.TransferInISV.IC_TransInBinDTOData>();
            foreach (BC.QuickTransIn.DocBinDataDTOData docBinDataDTOData in binDataDTOs)
            {
                list.Add(new ISV.TransferInISV.IC_TransInBinDTOData
                {
                    BinInfo = this.GetBinInfoData(docBinDataDTOData),
                    CreatedOn = DateTime.Now,
                    StoreUOMQty = docBinDataDTOData.Qty
                });
            }
            return list;
        }

        private void Set_IC_TransInSubLineDTOData(ISV.TransferInISV.IC_TransInSubLineDTOData subline, CBO.SCM.Warehouse.Warehouse outWh, BC.QuickTransIn.CreateDocDataDTOData docDto, BC.QuickTransIn.CreateDocParamDTOData dto)
        {
            subline.CreatedBy = Base.Context.LoginUser;
            subline.CreatedOn = DateTime.Now;
            subline.TransOutOrg = this.GetOrg(outWh.Org);
            subline.TransOutOwnerOrg = this.GetOwnerOrg(outWh.Org, docDto.OwnerOrgCode);
            subline.TransOutWh = this.GetWhData(outWh);
            if (subline.TransOutOrg.ID == Base.Context.LoginOrg.ID)
            {
                subline.TransOutWhMan = this.GetWhManData();
            }
            if (outWh.IsLot)
            {
                subline.LotInfo = BC.BCRestSV.Public.BCRestSVHelper.GetLotInfo(outWh.OrgKey.ID, docDto.ItemCode, docDto.LotCode);
            }
            subline.Project = BC.BCRestSV.Public.BCRestSVHelper.GetProjectInfo(outWh.OrgKey.ID, docDto.ProjectCode);
            subline.Seiban = BC.BCRestSV.Public.BCRestSVHelper.GetSeibanInfo(outWh.OrgKey.ID, docDto.SeibanCode);
            subline.ZeroCost = false;
            subline.StoreUOM = this.GetinvUOMData(docDto.InvUOMCode);
            subline.StoreUOMQty = Convert.ToDecimal(docDto.Qty);
            subline.StorageType = 4;
            if (docDto.TransOutDataDTO != null)
            {
                subline.TransOutDept = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                subline.TransOutDept.ID = docDto.TransOutDataDTO.TransOutDept;
                subline.TransOutCustInfo = new CBO.SCM.Customer.CustomerMISCInfoData();
                subline.TransOutCustInfo.Customer = docDto.TransOutDataDTO.TransOutCustinfo;
                subline.TransOutSuppInfo = new CBO.SCM.Supplier.SupplierMISCInfoData();
                subline.TransOutSuppInfo.Supplier = this.GetSupplierByCode(outWh.Org.ID, docDto.TransOutDataDTO.TransOutSupplierCode);
                subline.TransOutSite = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                subline.TransOutSite.ID = docDto.TransOutDataDTO.TransOutSite;
                subline.IsVMI = docDto.TransOutDataDTO.IsVMI;
                subline.ZeroCost = docDto.TransOutDataDTO.ZeroCost;
                subline.TransInBins = this.Set_IC_TransInBinDTOData(docDto.TransOutDataDTO.OutBinDataDTOs);
            }
        }

        private List<BC.QuickTransIn.RtnDTOData> CreateBarCodeUsed(List<CBO.Pub.Controller.CommonArchiveDataDTOData> reDTOList, List<BC.QuickTransIn.CreateDocDataDTOData> dataList)
        {
            List<BC.CalcData.CreateBarCodeUsedInDTO> list = new List<BC.CalcData.CreateBarCodeUsedInDTO>();
            List<BC.QuickTransIn.RtnDTOData> list2 = new List<BC.QuickTransIn.RtnDTOData>();
            foreach (CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData in reDTOList)
            {
                InvDoc.TransferIn.TransferIn transferIn = InvDoc.TransferIn.TransferIn.Finder.FindByID(commonArchiveDataDTOData.ID);
                foreach (InvDoc.TransferIn.TransInLine transInLine in transferIn.TransInLines)
                {
                    List<BC.QuickTransIn.CreateDocBCDataDTOData> barCodes = this.GetBarCodes(transInLine, dataList);
                    foreach (InvDoc.TransferIn.TransInSubLine transInSubLine in transInLine.TransInSubLines)
                    {
                        foreach (BC.QuickTransIn.CreateDocBCDataDTOData createDocBCDataDTOData in barCodes)
                        {
                            BC.CalcData.CreateBarCodeUsedInDTO createBarCodeUsedInDTO = new BC.CalcData.CreateBarCodeUsedInDTO();
                            createBarCodeUsedInDTO.BarCode = createDocBCDataDTOData.BarCode;
                            createBarCodeUsedInDTO.CurQty = createDocBCDataDTOData.WhQty;
                            createBarCodeUsedInDTO.IsUpdateWh = false;
                            createBarCodeUsedInDTO.Direct = BC.Common.DirectEnum.Undefine;
                            createBarCodeUsedInDTO.DocOrg = transferIn.Org.Key;
                            createBarCodeUsedInDTO.Doc = new Base.PropertyTypes.BizEntityKey(transferIn.Key.ID, transferIn.Key.EntityType);
                            createBarCodeUsedInDTO.DocLine = new Base.PropertyTypes.BizEntityKey(transInLine.Key.ID, transInLine.Key.EntityType);
                            createBarCodeUsedInDTO.DocNo = transferIn.DocNo;
                            createBarCodeUsedInDTO.DocLineNo = transInLine.DocLineNo.ToString();
                            if (transInSubLine != null)
                            {
                                createBarCodeUsedInDTO.SubLine = new Base.PropertyTypes.BizEntityKey(transInSubLine.Key.ID, transInSubLine.Key.EntityType);
                                createBarCodeUsedInDTO.DocSubLineNo = transInSubLine.DocLineNo.ToString();
                            }
                            if (transInLine.ItemInfo != null)
                            {
                                createBarCodeUsedInDTO.Item = transInLine.ItemInfo.ItemID.Key;
                                createBarCodeUsedInDTO.ItemCode = transInLine.ItemInfo.ItemCode;
                                createBarCodeUsedInDTO.ItemName = transInLine.ItemInfo.ItemName;
                            }
                            list.Add(createBarCodeUsedInDTO);
                            BC.QuickTransIn.RtnDTOData rtnDTOData = new BC.QuickTransIn.RtnDTOData();
                            rtnDTOData.IsSuccess = true;
                            rtnDTOData.BarCode = createDocBCDataDTOData.BarCode;
                            rtnDTOData.DocNo = transferIn.DocNo;
                            rtnDTOData.DocID = transferIn.Key.ID;
                            rtnDTOData.DocType = transferIn.Key.EntityType;
                            rtnDTOData.LineNum = transInLine.DocLineNo.ToString();
                            rtnDTOData.DocLineID = transInLine.Key.ID;
                            rtnDTOData.DocLineType = transInLine.Key.EntityType;
                            if (transInSubLine != null)
                            {
                                rtnDTOData.DocSubLineID = transInSubLine.Key.ID;
                                rtnDTOData.DocSubLineType = transInSubLine.Key.EntityType;
                                rtnDTOData.DocSubLineNo = transInSubLine.DocLineNo.ToString();
                            }
                            list2.Add(rtnDTOData);
                        }
                    }
                }
            }
            new BC.CalcData.CreateBarCodeUsedSV
            {
                App = 11,
                CreateBCUsedInParams = list
            }.Do();
            return list2;
        }

        private List<BC.QuickTransIn.CreateDocBCDataDTOData> GetBarCodes(InvDoc.TransferIn.TransInLine line, List<BC.QuickTransIn.CreateDocDataDTOData> dataList)
        {
            foreach (BC.QuickTransIn.CreateDocDataDTOData createDocDataDTOData in dataList)
            {
                if (!(line.ItemInfo == null))
                {
                    if (createDocDataDTOData.ItemCode == line.ItemInfo.ItemCode && ((line.TransInWh.IsLot && line.LotInfo != null && createDocDataDTOData.LotCode == line.LotInfo.LotCode) || !line.TransInWh.IsLot) && ((line.ProjectKey != null && createDocDataDTOData.ProjectCode == line.Project.Code) || line.ProjectKey == null) && ((line.Seiban != null && createDocDataDTOData.SeibanCode == line.Seiban.SeibanNO) || line.Seiban == null) && ((line.ManufacturerInfo != null && createDocDataDTOData.SupplierCode == line.ManufacturerInfo.Code) || line.ManufacturerInfo == null) && ((line.ItemInfo != null && createDocDataDTOData.Grade == line.ItemInfo.ItemGrade.Value) || line.ItemInfo == null) && ((line.ItemInfo != null && createDocDataDTOData.Potency == line.ItemInfo.ItemPotency.Value) || line.ItemInfo == null))
                    {
                        return createDocDataDTOData.BarCodes;
                    }
                }
            }
            return new List<BC.QuickTransIn.CreateDocBCDataDTOData>();
        }
    }

    #endregion


}