﻿namespace UFIDA.U9.Cust.Kusi.CJJ.RestApi
{
	using System;
	using System.Collections.Generic;
    using System.Data;
    using System.Text;
    using UFSoft.UBF.AopFrame;
    using UFSoft.UBF.Util.Context;
    using UFSoft.UBF.Util.DataAccess;

    /// <summary>
    /// CreateMiscRcvTransWithPackage partial 
    /// </summary>	
    public partial class CreateMiscRcvTransWithPackage
    {	
		internal BaseStrategy Select()
		{
			return new CreateMiscRcvTransWithPackageImpementStrategy();	
		}		
	}
	
	#region  implement strategy	
	/// <summary>
	/// Impement Implement
	/// 
	/// </summary>	
	internal partial class CreateMiscRcvTransWithPackageImpementStrategy : BaseStrategy
	{
		public CreateMiscRcvTransWithPackageImpementStrategy() { }

		public override object Do(object obj)
		{						
			CreateMiscRcvTransWithPackage bpObj = (CreateMiscRcvTransWithPackage)obj;

            object result;
            using (UFSoft.UBF.Business.ISession session = UFSoft.UBF.Business.Session.Open())
            {
                List<ISV.INV.MiscShipmentLineDTOData> lineDTOs = bpObj.LineDTOs;
                if (lineDTOs == null || lineDTOs.Count <= 0)
                {
                    result = "行不能为空";
                }
                else
                {
					ISV.Mobile.MO.ResultDTOData resultDTOData = new ISV.Mobile.MO.ResultDTOData();
                    List<string> barCodes = new List<string>();
                    List<BC.CalcData.CreateBarCodeUsedInDTOData> usedtos = new List<BC.CalcData.CreateBarCodeUsedInDTOData>();
                    List<CBO.Pub.Controller.CommonArchiveDataDTOData> list = new List<CBO.Pub.Controller.CommonArchiveDataDTOData>();
                    list = this.CreateDoc(lineDTOs);
                    if (this.DocStatus > 0)
                    {
                        this.ApproveDoc(list);
                    }
                    this.UpdateBarCodeState(barCodes);
                    this.ItemBarCodeUseDetailDatas(list, lineDTOs, barCodes, usedtos);
                    this.CreateItemBarCodeUseDetail(usedtos);
                    session.Commit();
                    result = resultDTOData;
                }
            }
            return result;
        }

        private List<CBO.Pub.Controller.CommonArchiveDataDTOData> CreateDoc(List<ISV.INV.MiscShipmentLineDTOData> linedtos)
        {
            List<ISV.MiscRcvISV.IC_MiscRcvDTOData> list = new List<ISV.MiscRcvISV.IC_MiscRcvDTOData>();

            ISV.MiscRcvISV.IC_MiscRcvDTOData ic_MiscRcvDTOData = new ISV.MiscRcvISV.IC_MiscRcvDTOData();
            this.SetHeadValue(ic_MiscRcvDTOData, linedtos[0]);

            ic_MiscRcvDTOData.MiscRcvTransLs = new List<ISV.MiscRcvISV.IC_MiscRcvTransLsDTOData>();
            this.CreateLines(ic_MiscRcvDTOData, linedtos);
            list.Add(ic_MiscRcvDTOData);

            ISV.MiscRcvISV.Proxy.CommonCreateMiscRcvProxy commonCreateMiscRcvProxy = new ISV.MiscRcvISV.Proxy.CommonCreateMiscRcvProxy();
            commonCreateMiscRcvProxy.MiscRcvDTOList = list;
            List<CBO.Pub.Controller.CommonArchiveDataDTOData> list2 = new List<CBO.Pub.Controller.CommonArchiveDataDTOData>();
            return commonCreateMiscRcvProxy.Do();
        }

        private void SetHeadValue(ISV.MiscRcvISV.IC_MiscRcvDTOData miscRcv, ISV.INV.MiscShipmentLineDTOData ldto)
        {
            StringBuilder stringBuilder = new StringBuilder();
            long id = Base.Context.LoginOrg.ID;
            InvDoc.MiscRcv.MiscRcvDocType miscRcvDocType = new InvDoc.MiscRcv.MiscRcvDocType();
            if (!string.IsNullOrEmpty(ldto.BenefitOrgCode))
            {
                Base.Organization.Organization organization = Base.Organization.Organization.FindByCode(ldto.BenefitOrgCode);
                if (organization != null)
                {
                    miscRcv.BenefitOrg = organization.ID;
                    this.benefitOrg = organization;
                }
            }
            else
            {
                this.benefitOrg = Base.Context.LoginOrg;
            }
            if (!string.IsNullOrEmpty(ldto.DocTypeCode))
            {
                stringBuilder.Append("Code =@code and org=@longinOrgID");
                miscRcvDocType = InvDoc.MiscRcv.MiscRcvDocType.Finder.Find(stringBuilder.ToString(), new UFSoft.UBF.PL.OqlParam[]
                {
                    new UFSoft.UBF.PL.OqlParam(ldto.DocTypeCode),
                    new UFSoft.UBF.PL.OqlParam(this.benefitOrg.ID)
                });
            }
            else
            {
                stringBuilder.Append("IsCreatedByPush = 1  and DocHeaderSequenceStyle =0  and org=@longinOrgID");
                miscRcvDocType = InvDoc.MiscRcv.MiscRcvDocType.Finder.Find(stringBuilder.ToString(), new UFSoft.UBF.PL.OqlParam[]
                {
                    new UFSoft.UBF.PL.OqlParam(this.benefitOrg.ID)
                });
            }
            if (miscRcvDocType == null)
            {
                throw new Exception("请设置单据类型，或没有找到设置[上游单据推出]且自动编码的单据类型");
            }
            miscRcv.MiscRcvDocType = new CBO.Pub.Controller.CommonArchiveDataDTOData();
            miscRcv.MiscRcvDocType.ID = miscRcvDocType.ID;
            miscRcv.MiscRcvDocType.Code = miscRcvDocType.Code;
            this.isMFG = miscRcvDocType.IsMFG;
            if (this.whman == null)
            {
                CBO.HR.Operator.Operators currentDepotOperators = CBO.HR.Operator.Operators.GetCurrentDepotOperators();
                if (currentDepotOperators != null)
                {
                    this.whman = currentDepotOperators;
                    miscRcv.WhMan = this.whman.ID;
                }
            }
            if (string.IsNullOrEmpty(ldto.WhCode))
            {
                throw new Exception("请录入存储地点");
            }
            CBO.SCM.Warehouse.Warehouse warehouse = CBO.SCM.Warehouse.Warehouse.Finder.Find("Org =@orgid and Code=@whcode", new UFSoft.UBF.PL.OqlParam[]
            {
                new UFSoft.UBF.PL.OqlParam("orgid", Base.Context.LoginOrg.ID),
                new UFSoft.UBF.PL.OqlParam("whcode", ldto.WhCode)
            });
            if (warehouse == null)
            {
                throw new Exception(string.Concat(new string[]
                {
                    "组织",
                    Base.Context.LoginOrg.Name,
                    "不存在编码为",
                    ldto.WhCode,
                    "的存储地点，请重新选择存储地点"
                }));
            }
            this.wh = warehouse;
            if (this.whman == null && warehouse.ManagerKey != null)
            {
                this.whman = warehouse.Manager;
                miscRcv.WhMan = this.whman.ID;
            }
            this.DocStatus = ldto.DocStatus;
        }

        private void CreateLines(ISV.MiscRcvISV.IC_MiscRcvDTOData miscRcv, List<ISV.INV.MiscShipmentLineDTOData> linedtos)
        {
            foreach (ISV.INV.MiscShipmentLineDTOData miscShipmentLineDTOData in linedtos)
            {
                if (!(miscShipmentLineDTOData.TotalQty <= 0m))
                {
                    ISV.MiscRcvISV.IC_MiscRcvTransLsDTOData ic_MiscRcvTransLsDTOData = new ISV.MiscRcvISV.IC_MiscRcvTransLsDTOData();
                    this.SetLineValue(ic_MiscRcvTransLsDTOData, miscShipmentLineDTOData);
                    if (miscShipmentLineDTOData.BinDtos != null && miscShipmentLineDTOData.BinDtos.Count > 0)
                    {
                        ic_MiscRcvTransLsDTOData.CostUOMQty = 0m;
                        foreach (ISV.INV.binDtoData binDtoData in miscShipmentLineDTOData.BinDtos)
                        {
                            //foreach (ISV.INV.barDtoData barDtoData in binDtoData.BarCodes)
                            //{
                            //    ic_MiscRcvTransLsDTOData.CostUOMQty += barDtoData.Qty;
                            //}
                            ic_MiscRcvTransLsDTOData.CostUOMQty = GetTotalCostUOMQty(binDtoData.BarCodes);

                            if (!string.IsNullOrEmpty(binDtoData.BinCode))
                            {
                                ic_MiscRcvTransLsDTOData.Wh.ID = binDtoData.WhID;
                                CBO.SCM.Warehouse.Warehouse warehouse = CBO.SCM.Warehouse.Warehouse.Finder.Find("Org =@orgid and Code=@whcode", new UFSoft.UBF.PL.OqlParam[]
                                {
                                    new UFSoft.UBF.PL.OqlParam("orgid", Base.Context.LoginOrg.ID),
                                    new UFSoft.UBF.PL.OqlParam("whcode", binDtoData.WhCode)
                                });
                                if (warehouse == null)
                                {
                                    throw new Exception(string.Concat(new string[]
                                    {
                                        "组织",
                                        Base.Context.LoginOrg.Name,
                                        "不存在编码为",
                                        miscShipmentLineDTOData.WhCode,
                                        "的存储地点，请重新选择存储地点"
                                    }));
                                }
                                ic_MiscRcvTransLsDTOData.Wh.ID = warehouse.ID;
                                ic_MiscRcvTransLsDTOData.Wh.Code = warehouse.Code;
                                ic_MiscRcvTransLsDTOData.Wh.Name = warehouse.Name;
                                ic_MiscRcvTransLsDTOData.StoreType = warehouse.StorageType.Value;
                                if (binDtoData.BarCodes != null && binDtoData.BarCodes.Count > 0)
                                {
                                    ISV.MiscRcvISV.IC_MiscRcvTransBinsDTOData ic_MiscRcvTransBinsDTOData = new ISV.MiscRcvISV.IC_MiscRcvTransBinsDTOData();
                                    ic_MiscRcvTransBinsDTOData.BinInfo = new CBO.SCM.Bin.BinInfoData();
                                    ic_MiscRcvTransBinsDTOData.BinInfo.Bin = binDtoData.BinID;
                                    ic_MiscRcvTransBinsDTOData.BinInfo.Code = binDtoData.BinCode;
                                    ic_MiscRcvTransBinsDTOData.BinInfo.Name = binDtoData.BinName;
                                    ic_MiscRcvTransBinsDTOData.StoreUOMQty = 0m;
                                    //foreach (ISV.INV.barDtoData barDtoData in binDtoData.BarCodes)
                                    //{
                                    //    ic_MiscRcvTransBinsDTOData.StoreUOMQty += barDtoData.Qty;
                                    //}
                                    ic_MiscRcvTransBinsDTOData.StoreUOMQty = GetTotalCostUOMQty(binDtoData.BarCodes);
                                    ic_MiscRcvTransLsDTOData.MiscRcvTransBins.Add(ic_MiscRcvTransBinsDTOData);
                                }
                            }
                        }
                    }
                    miscRcv.MiscRcvTransLs.Add(ic_MiscRcvTransLsDTOData);
                }
            }
        }

        private decimal GetTotalCostUOMQty(List<ISV.INV.barDtoData> barDtoDatas)
        {
            decimal totalQty = 0;

            StringBuilder sb = new StringBuilder();
            foreach (var dto in barDtoDatas)
            {
                sb.AppendFormat("{0},", dto.BarCode);
            }

            DataParamList dataParams = new DataParamList
            {
                DataParamFactory.CreateInput("BarCodes", sb.ToString(0, sb.Length - 1), DbType.String),
                DataParamFactory.CreateInput("OrgCode", Base.Context.LoginOrg.Code, DbType.String)
            };

            DataAccessor.RunSP("SP_Cust_PDA_GetPackageCompleteQty", dataParams, out System.Data.DataSet dataSet);
            if (dataSet != null && dataSet.Tables.Count > 0 && dataSet.Tables[0].Rows.Count > 0)
            {
                totalQty = Convert.ToDecimal(dataSet.Tables[0].Rows[0][0]);
            }

            return totalQty;
        }

        private ISV.MiscRcvISV.IC_MiscRcvTransLsDTOData SetLineValue(ISV.MiscRcvISV.IC_MiscRcvTransLsDTOData line, ISV.INV.MiscShipmentLineDTOData linedto)
        {
            line.ItemInfo = new CBO.SCM.Item.ItemInfoData();
            bool flag = CBO.Pub.Controller.BaseObject.EntitytIsSend("UFIDA.U9.CBO.SCM.Item.ItemMaster");
            string text = "Code=@Code";
            UFSoft.UBF.PL.OqlParamList oqlParamList = new UFSoft.UBF.PL.OqlParamList();
            oqlParamList.Add(new UFSoft.UBF.PL.OqlParam(linedto.ItemCode));
            if (flag)
            {
                text += " and Org.Code=@OrgCode";
                oqlParamList.Add(new UFSoft.UBF.PL.OqlParam(Base.Context.LoginOrg.Code));
            }
            CBO.SCM.Item.ItemMaster itemMaster = CBO.SCM.Item.ItemMaster.Finder.Find(text, oqlParamList.ToArray());
            if (itemMaster != null)
            {
                line.ItemInfo.ItemID = itemMaster.ID;
                line.ItemInfo.ItemCode = itemMaster.Code;
                line.ItemInfo.ItemName = itemMaster.Name;
                if (linedto.Grade >= 0)
                {
                    line.FinishedItemGrade = linedto.Grade;
                }
                if (linedto.Element >= 0)
                {
                    line.FinishedItemPotency = linedto.Element;
                }
                if (!string.IsNullOrEmpty(linedto.BenefitWhCode))
                {
                    CBO.SCM.Warehouse.Warehouse warehouse = CBO.SCM.Warehouse.Warehouse.Finder.Find("Code =@code and Org =@orgid", new UFSoft.UBF.PL.OqlParam[]
                    {
                        new UFSoft.UBF.PL.OqlParam("code", linedto.BenefitWhCode),
                        new UFSoft.UBF.PL.OqlParam("orgid", this.benefitOrg.ID)
                    });
                    if (warehouse != null)
                    {
                        line.BenefitWh = warehouse.ID;
                    }
                }
                if (this.wh != null && this.wh.ID > 0L)
                {
                    line.Wh = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                    line.Wh.ID = this.wh.ID;
                    line.Wh.Code = this.wh.Code;
                    line.Wh.Name = this.wh.Name;
                    line.StoreType = this.wh.StorageType.Value;
                }
                long projectID = linedto.ProjectID;
                if (linedto.ProjectID > 0L)
                {
                    line.Project = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                    line.Project.ID = linedto.ProjectID;
                    line.Project.Code = linedto.ProjectCode;
                    line.Project.Name = linedto.ProjectName;
                }
                if (this.whman != null && this.whman.ID > 0L)
                {
                    line.WhMan = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                    line.WhMan.ID = this.whman.ID;
                    line.WhMan.Code = this.whman.Code;
                    line.WhMan.Name = this.whman.Name;
                }
                long seiban = linedto.Seiban;
                if (linedto.Seiban > 0L)
                {
                    line.Seiban = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                    line.Seiban.ID = linedto.Seiban;
                    line.Seiban.Code = linedto.SeibanCode;
                }
                long supplier = linedto.Supplier;
                if (linedto.Supplier > 0L)
                {
                    line.SupplierInfo = new CBO.SCM.Supplier.SupplierMISCInfoData();
                    line.SupplierInfo.Supplier = linedto.Supplier;
                    line.SupplierInfo.Code = linedto.SupplierCode;
                    line.SupplierInfo.Name = linedto.SupplierName;
                }
                long manufacturer = linedto.Manufacturer;
                if (linedto.Manufacturer > 0L)
                {
                    line.ManufacturerInfo = new CBO.SCM.Supplier.SupplierMISCInfoData();
                    line.ManufacturerInfo.Supplier = linedto.Manufacturer;
                    line.ManufacturerInfo.Code = linedto.ManufacturerCode;
                    line.ManufacturerInfo.Name = linedto.ManufacturerName;
                }
                long ownerOrg = linedto.OwnerOrg;
                if (linedto.OwnerOrg > 0L)
                {
                    line.OwnerOrg = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                    line.OwnerOrg.ID = linedto.OwnerOrg;
                    line.OwnerOrg.Code = linedto.OwnerOrgCode;
                    line.OwnerOrg.Name = linedto.OwnerOrgName;
                }
                if (linedto.LotID > 0L)
                {
                    Lot.LotMaster lotMaster = Lot.LotMaster.Finder.FindByID(linedto.LotID);
                    if (lotMaster != null)
                    {
                        line.LotInfo = new CBO.SCM.PropertyTypes.LotInfoData();
                        line.LotInfo.LotMaster = new Base.PropertyTypes.BizEntityKeyData();
                        line.LotInfo.LotMaster.EntityID = lotMaster.ID;
                        line.LotInfo.LotCode = lotMaster.LotCode;
                        line.LotInfo.DisabledDatetime = lotMaster.InvalidTime;
                    }
                }
                else if (!string.IsNullOrEmpty(linedto.LotCode))
                {
                    Lot.LotMaster lotMaster = Lot.LotMaster.Finder.Find("LotCode =@code and Item =@item", new UFSoft.UBF.PL.OqlParam[]
                    {
                        new UFSoft.UBF.PL.OqlParam("code", linedto.LotCode),
                        new UFSoft.UBF.PL.OqlParam("item", itemMaster.ID)
                    });
                    if (lotMaster == null)
                    {
                        lotMaster = Lot.LotMaster.Finder.Find("LotCode =@code and Item.Code =@itemcode", new UFSoft.UBF.PL.OqlParam[]
                        {
                            new UFSoft.UBF.PL.OqlParam("code", linedto.LotCode),
                            new UFSoft.UBF.PL.OqlParam("itemcode", itemMaster.Code)
                        });
                    }
                    if (lotMaster != null)
                    {
                        line.LotInfo = new CBO.SCM.PropertyTypes.LotInfoData();
                        line.LotInfo.LotMaster = new Base.PropertyTypes.BizEntityKeyData();
                        line.LotInfo.LotMaster.EntityID = lotMaster.ID;
                        line.LotInfo.LotCode = lotMaster.LotCode;
                        line.LotInfo.DisabledDatetime = lotMaster.InvalidTime;
                    }
                }
                if (!string.IsNullOrEmpty(linedto.BenefitOrgCode))
                {
                    line.BenefitOrg = this.benefitOrg.ID;
                }
                if (!string.IsNullOrEmpty(linedto.BenefitDeptCode))
                {
                    CBO.HR.Department.Department department = CBO.HR.Department.Department.FindByCode(this.benefitOrg, linedto.BenefitDeptCode);
                    if (department != null)
                    {
                        line.BenefitDept = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                        line.BenefitDept.Code = department.Code;
                        line.BenefitDept.Name = department.Name;
                        line.BenefitDept.ID = department.ID;
                    }
                }
                line.IsMFG = this.isMFG;
                line.MiscRcvTransBins = new List<ISV.MiscRcvISV.IC_MiscRcvTransBinsDTOData>();
                return line;
            }
            throw new Exception("编码为" + linedto.ItemCode + "的料品不存在");
        }

        private void ApproveDoc(List<CBO.Pub.Controller.CommonArchiveDataDTOData> RtnMiscShipmentBizKeyDTOs)
        {
            if (RtnMiscShipmentBizKeyDTOs.Count > 0)
            {
                foreach (CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData in RtnMiscShipmentBizKeyDTOs)
                {
                    if (commonArchiveDataDTOData.ID > 0L)
                    {
                        InvDoc.MiscRcv.MiscRcvTrans miscRcvTrans = InvDoc.MiscRcv.MiscRcvTrans.Finder.FindByID(commonArchiveDataDTOData.ID);
                        if (miscRcvTrans != null)
                        {
                            ISV.MiscRcvISV.Proxy.CommonCommitMiscRcvProxy commonCommitMiscRcvProxy = new ISV.MiscRcvISV.Proxy.CommonCommitMiscRcvProxy();
                            commonCommitMiscRcvProxy.TargetOrgCode = Base.Context.LoginOrg.Code;
                            commonCommitMiscRcvProxy.TargetOrgName = Base.Context.LoginOrg.Name;
                            commonCommitMiscRcvProxy.MiscRcvKeys = new List<CBO.Pub.Controller.CommonArchiveDataDTOData>();
                            CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData2 = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                            commonArchiveDataDTOData2.ID = miscRcvTrans.ID;
                            commonCommitMiscRcvProxy.MiscRcvKeys.Add(commonArchiveDataDTOData2);
                            commonCommitMiscRcvProxy.Do();
                            if (this.DocStatus > 1)
                            {
                                if (miscRcvTrans.MiscRcvDocType != null && miscRcvTrans.MiscRcvDocType.ConfirmType != Base.Doc.ConfirmTypeEnum.ApproveFlow)
                                {
                                    ISV.MiscRcvISV.Proxy.CommonApproveMiscRcvProxy commonApproveMiscRcvProxy = new ISV.MiscRcvISV.Proxy.CommonApproveMiscRcvProxy();
                                    commonApproveMiscRcvProxy.TargetOrgCode = Base.Context.LoginOrg.Code;
                                    commonApproveMiscRcvProxy.TargetOrgName = Base.Context.LoginOrg.Name;
                                    commonApproveMiscRcvProxy.MiscRcvKeys = new List<CBO.Pub.Controller.CommonArchiveDataDTOData>();
                                    CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData3 = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                                    commonArchiveDataDTOData3.ID = miscRcvTrans.ID;
                                    commonApproveMiscRcvProxy.MiscRcvKeys.Add(commonArchiveDataDTOData3);
                                    commonApproveMiscRcvProxy.Do();
                                }
                            }
                        }
                    }
                }
            }
        }

        private void UpdateBarCodeState(List<string> barCodes)
        {
            if (barCodes.Count > 0)
            {
                new BC.CalcData.Proxy.UpdateBarCodeStateProxy
                {
                    BarCodes = barCodes
                }.Do();
            }
        }

        private void ItemBarCodeUseDetailDatas(List<CBO.Pub.Controller.CommonArchiveDataDTOData> RtnmiscRcvmentBizKeyDTOs, List<ISV.INV.MiscShipmentLineDTOData> linedtos, List<string> barCodes, List<BC.CalcData.CreateBarCodeUsedInDTOData> usedtos)
        {
            if (RtnmiscRcvmentBizKeyDTOs.Count > 0)
            {
                foreach (CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData in RtnmiscRcvmentBizKeyDTOs)
                {
                    if (commonArchiveDataDTOData.ID > 0L)
                    {
                        InvDoc.MiscRcv.MiscRcvTransL.EntityList entityList = InvDoc.MiscRcv.MiscRcvTransL.Finder.FindAll("MiscRcvTrans = @docid", new UFSoft.UBF.PL.OqlParam[]
                        {
                            new UFSoft.UBF.PL.OqlParam("docid", commonArchiveDataDTOData.ID)
                        });
                        if (entityList != null)
                        {
                            foreach (InvDoc.MiscRcv.MiscRcvTransL miscRcvTransL in entityList)
                            {
                                foreach (ISV.INV.MiscShipmentLineDTOData miscShipmentLineDTOData in linedtos)
                                {
                                    if (miscShipmentLineDTOData.ItemCode == miscRcvTransL.ItemInfo.ItemCode && ((miscRcvTransL.LotInfo != null && miscShipmentLineDTOData.LotCode != "-100" && miscShipmentLineDTOData.LotCode != "" && miscShipmentLineDTOData.LotCode == miscRcvTransL.LotInfo.LotCode) || ((miscRcvTransL.LotInfo == null || miscRcvTransL.LotInfo.LotMasterKey == null) && (miscShipmentLineDTOData.LotCode == "-100" || miscShipmentLineDTOData.LotCode == ""))) && ((miscRcvTransL.ProjectKey != null && miscShipmentLineDTOData.ProjectCode != "-100" && miscShipmentLineDTOData.ProjectCode != "" && miscShipmentLineDTOData.ProjectCode == miscRcvTransL.Project.Code) || (miscRcvTransL.ProjectKey == null && (miscShipmentLineDTOData.ProjectCode == "-100" || miscShipmentLineDTOData.ProjectCode == ""))) && ((miscRcvTransL.Seiban != null && miscShipmentLineDTOData.SeibanCode != "-100" && miscShipmentLineDTOData.SeibanCode != "" && miscShipmentLineDTOData.SeibanCode == miscRcvTransL.Seiban.SeibanNO) || (miscRcvTransL.Seiban == null && (miscShipmentLineDTOData.SeibanCode == "-100" || miscShipmentLineDTOData.SeibanCode == ""))) && ((miscRcvTransL.ManufacturerInfo != null && miscRcvTransL.ManufacturerInfo.SupplierKey != null && miscShipmentLineDTOData.ManufacturerCode != "-100" && miscShipmentLineDTOData.ManufacturerCode != "" && miscShipmentLineDTOData.ManufacturerCode == miscRcvTransL.ManufacturerInfo.Supplier.Code) || ((miscRcvTransL.ManufacturerInfo == null || miscRcvTransL.ManufacturerInfo.SupplierKey == null) && (miscShipmentLineDTOData.ManufacturerCode == "-100" || miscShipmentLineDTOData.ManufacturerCode == ""))) && (miscShipmentLineDTOData.Grade == miscRcvTransL.FinishedItemGrade.Value || miscShipmentLineDTOData.Grade < 0) && (miscShipmentLineDTOData.Element == miscRcvTransL.FinishedItemPotency.Value || miscShipmentLineDTOData.Element < 0) && ((miscRcvTransL.WhKey != null && miscShipmentLineDTOData.WhCode == miscRcvTransL.Wh.Code) || miscRcvTransL.WhKey == null))
                                    {
                                        foreach (ISV.INV.binDtoData bindto in miscShipmentLineDTOData.BinDtos)
                                        {
                                            this.ItemBarCodeUseDetail(bindto, miscRcvTransL, barCodes, usedtos);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        private void ItemBarCodeUseDetail(ISV.INV.binDtoData bindto, InvDoc.MiscRcv.MiscRcvTransL line, List<string> barCodes, List<BC.CalcData.CreateBarCodeUsedInDTOData> usedtos)
        {
            foreach (ISV.INV.barDtoData barDtoData in bindto.BarCodes)
            {
                BC.CalcData.CreateBarCodeUsedInDTOData createBarCodeUsedInDTOData = new BC.CalcData.CreateBarCodeUsedInDTOData();
                usedtos.Add(createBarCodeUsedInDTOData);
                createBarCodeUsedInDTOData.BarCode = barDtoData.BarCode;
                createBarCodeUsedInDTOData.Doc = new Base.PropertyTypes.BizEntityKeyData();
                createBarCodeUsedInDTOData.Doc.EntityID = line.MiscRcvTrans.ID;
                createBarCodeUsedInDTOData.Doc.EntityType = "UFIDA::U9::InvDoc::MiscRcv::MiscRcvTrans";
                createBarCodeUsedInDTOData.DocLine = new Base.PropertyTypes.BizEntityKeyData();
                createBarCodeUsedInDTOData.DocLine.EntityID = line.ID;
                createBarCodeUsedInDTOData.DocLine.EntityType = "UFIDA::U9::InvDoc::MiscRcv::MiscRcvTransL";
                createBarCodeUsedInDTOData.Item = line.ItemInfo.ItemID.ID;
                createBarCodeUsedInDTOData.ItemCode = line.ItemInfo.ItemCode;
                createBarCodeUsedInDTOData.ItemName = line.ItemInfo.ItemName;
                createBarCodeUsedInDTOData.Org = Base.Context.LoginOrg.ID;
                createBarCodeUsedInDTOData.DocNo = line.MiscRcvTrans.DocNo;
                createBarCodeUsedInDTOData.DocLineNo = line.DocLineNo.ToString();
                createBarCodeUsedInDTOData.DocOrg = Base.Context.LoginOrg.ID;
                createBarCodeUsedInDTOData.CurQty = barDtoData.Qty;
                createBarCodeUsedInDTOData.Direct = BC.Common.DirectEnum.Rcv.Value;
                createBarCodeUsedInDTOData.IsUpdateWh = true;
                barCodes.Add(barDtoData.BarCode);
            }
        }

        private void CreateItemBarCodeUseDetail(List<BC.CalcData.CreateBarCodeUsedInDTOData> usedtos)
        {
            if (usedtos.Count > 0)
            {
                new BC.CalcData.Proxy.CreateBarCodeUsedSVProxy
                {
                    CreateBCUsedInParams = usedtos,
                    App = 26
                }.Do();
            }
        }


        public bool isMFG = false;

        public int DocStatus = -1;

        public Base.Organization.Organization benefitOrg = null;

        public CBO.HR.Operator.Operators whman = null;

        public CBO.SCM.Warehouse.Warehouse wh = null;
    }

	#endregion
	
	
}