﻿namespace UFIDA.U9.Cust.Kusi.CJJ.RestApi
{
	using System;
	using System.Collections.Generic;
    using System.Text;
    using UFIDA.U9.Base.Profile;
    using UFSoft.UBF.AopFrame;
    using UFSoft.UBF.PL;
    using UFSoft.UBF.Util.Context;

    /// <summary>
    /// CreateMiscShipmentWithPackageSV partial 
    /// </summary>	
    public partial class CreateMiscShipmentWithPackageSV
    {
        internal BaseStrategy Select()
        {
            return new CreateMiscShipmentWithPackageSVImpementStrategy();
        }
    }

    #region  implement strategy	
    /// <summary>
    /// Impement Implement
    /// 
    /// </summary>	
    internal partial class CreateMiscShipmentWithPackageSVImpementStrategy : BaseStrategy
    {
        public CreateMiscShipmentWithPackageSVImpementStrategy() { }
        public override object Do(object obj)
        {
            CreateMiscShipmentWithPackageSV bpObj = (CreateMiscShipmentWithPackageSV)obj;

            List<ISV.INV.MiscShipmentLineDTOData> lineDTOs = bpObj.LineDTOs;
            string str = "";
            using (UFSoft.UBF.Business.ISession session = UFSoft.UBF.Business.Session.Open())
            {
                List<ISV.MiscShipISV.IC_MiscShipmentDTOData> list = new List<ISV.MiscShipISV.IC_MiscShipmentDTOData>();
                List<string> list2 = new List<string>();
                List<BC.CalcData.CreateBarCodeUsedInDTOData> list3 = new List<BC.CalcData.CreateBarCodeUsedInDTOData>();
                if (lineDTOs == null || lineDTOs.Count <= 0)
                {
                    return "行不能为空";
                }
                ISV.MiscShipISV.IC_MiscShipmentDTOData ic_MiscShipmentDTOData = new ISV.MiscShipISV.IC_MiscShipmentDTOData();
                StringBuilder stringBuilder = new StringBuilder();
                long id = Base.Context.LoginOrg.ID;
                InvDoc.MiscShip.MiscShipDocType miscShipDocType = new InvDoc.MiscShip.MiscShipDocType();
                ISV.INV.MiscShipmentLineDTOData miscShipmentLineDTOData = lineDTOs[0];
                if (!string.IsNullOrEmpty(miscShipmentLineDTOData.BenefitOrgCode))
                {
                    Base.Organization.Organization organization = Base.Organization.Organization.FindByCode(miscShipmentLineDTOData.BenefitOrgCode);
                    if (organization != null)
                    {
                        ic_MiscShipmentDTOData.BenefitOrg = organization.ID;
                        this.benefitOrg = organization;
                    }
                }
                else
                {
                    this.benefitOrg = Base.Context.LoginOrg;
                }
                if (!string.IsNullOrEmpty(miscShipmentLineDTOData.DocTypeCode))
                {
                    stringBuilder.Append("Code =@code and org=@longinOrgID");
                    miscShipDocType = InvDoc.MiscShip.MiscShipDocType.Finder.Find(stringBuilder.ToString(), new UFSoft.UBF.PL.OqlParam[]
                    {
                        new UFSoft.UBF.PL.OqlParam(miscShipmentLineDTOData.DocTypeCode),
                        new UFSoft.UBF.PL.OqlParam(this.benefitOrg.ID)
                    });
                }
                else
                {
                    stringBuilder.Append("IsCreatedByPush = 1  and DocHeaderSequenceStyle =0  and org=@longinOrgID");
                    miscShipDocType = InvDoc.MiscShip.MiscShipDocType.Finder.Find(stringBuilder.ToString(), new UFSoft.UBF.PL.OqlParam[]
                    {
                        new UFSoft.UBF.PL.OqlParam(this.benefitOrg.ID)
                    });
                }
                if (miscShipDocType == null)
                {
                    throw new Exception("请设置单据类型，或没有找到设置[上游单据推出]且自动编码的单据类型");
                }
                ic_MiscShipmentDTOData.MiscShipDocType = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                ic_MiscShipmentDTOData.MiscShipDocType.ID = miscShipDocType.ID;
                ic_MiscShipmentDTOData.MiscShipDocType.Code = miscShipDocType.Code;
                CBO.HR.Operator.Operators currentDepotOperators = CBO.HR.Operator.Operators.GetCurrentDepotOperators();
                if (currentDepotOperators != null)
                {
                    this.whman = currentDepotOperators;
                }
                if (string.IsNullOrEmpty(miscShipmentLineDTOData.WhCode))
                {
                    throw new Exception("请录入存储地点");
                }
                CBO.SCM.Warehouse.Warehouse warehouse = CBO.SCM.Warehouse.Warehouse.Finder.Find("Org =@orgid and Code=@whcode", new UFSoft.UBF.PL.OqlParam[]
                {
                    new UFSoft.UBF.PL.OqlParam("orgid", Base.Context.LoginOrg.ID),
                    new UFSoft.UBF.PL.OqlParam("whcode", miscShipmentLineDTOData.WhCode)
                });
                if (warehouse == null)
                {
                    throw new Exception(string.Concat(new string[]
                    {
                        "组织",
                        Base.Context.LoginOrg.Name,
                        "不存在编码为",
                        miscShipmentLineDTOData.WhCode,
                        "的存储地点，请重新选择存储地点"
                    }));
                }
                this.wh = warehouse;
                if (this.whman == null && warehouse.ManagerKey != null)
                {
                    this.whman = warehouse.Manager;
                }
                if (this.whman != null)
                {
                    ic_MiscShipmentDTOData.WhMan = this.whman.Key.ID;
                }
                ic_MiscShipmentDTOData.MiscShipLs = new List<ISV.MiscShipISV.IC_MiscShipmentLDTOData>();
                foreach (ISV.INV.MiscShipmentLineDTOData miscShipmentLineDTOData2 in lineDTOs)
                {
                    this.DocStatus = miscShipmentLineDTOData2.DocStatus;
                    if (miscShipmentLineDTOData2.Whlist != null && miscShipmentLineDTOData2.Whlist.Count > 0)
                    {
                        foreach (string b in miscShipmentLineDTOData2.Whlist)
                        {
                            ISV.MiscShipISV.IC_MiscShipmentLDTOData ic_MiscShipmentLDTOData = new ISV.MiscShipISV.IC_MiscShipmentLDTOData();
                            this.SetLineValue(miscShipDocType, ic_MiscShipmentLDTOData, miscShipmentLineDTOData2);
                            if (miscShipmentLineDTOData2.BinDtos != null && miscShipmentLineDTOData2.BinDtos.Count > 0)
                            {
                                foreach (ISV.INV.binDtoData binDtoData in miscShipmentLineDTOData2.BinDtos)
                                {
                                    if (!string.IsNullOrEmpty(binDtoData.BinCode))
                                    {
                                        if (!(binDtoData.WhCode != b))
                                        {
                                            warehouse = CBO.SCM.Warehouse.Warehouse.Finder.Find("Org =@orgid and Code=@whcode", new UFSoft.UBF.PL.OqlParam[]
                                            {
                                                new UFSoft.UBF.PL.OqlParam("orgid", Base.Context.LoginOrg.ID),
                                                new UFSoft.UBF.PL.OqlParam("whcode", binDtoData.WhCode)
                                            });
                                            if (warehouse == null)
                                            {
                                                throw new Exception(string.Concat(new string[]
                                                {
                                                    "组织",
                                                    Base.Context.LoginOrg.Name,
                                                    "不存在编码为",
                                                    miscShipmentLineDTOData2.WhCode,
                                                    "的存储地点，请重新选择存储地点"
                                                }));
                                            }
                                            ic_MiscShipmentLDTOData.Wh.ID = warehouse.ID;
                                            ic_MiscShipmentLDTOData.Wh.Code = warehouse.Code;
                                            ic_MiscShipmentLDTOData.Wh.Name = warehouse.Name;
                                            ic_MiscShipmentLDTOData.StoreType = warehouse.StorageType.Value;
                                            if (binDtoData.BarCodes != null && binDtoData.BarCodes.Count > 0)
                                            {
                                                ISV.MiscShipISV.IC_MiscShipBinDTOData ic_MiscShipBinDTOData = new ISV.MiscShipISV.IC_MiscShipBinDTOData();
                                                ic_MiscShipBinDTOData.BinInfo = new CBO.SCM.Bin.BinInfoData();
                                                ic_MiscShipBinDTOData.BinInfo.Bin = binDtoData.BinID;
                                                ic_MiscShipBinDTOData.BinInfo.Code = binDtoData.BinCode;
                                                ic_MiscShipBinDTOData.BinInfo.Name = binDtoData.BinName;
                                                ic_MiscShipBinDTOData.StoreUOMQty = 0m;

                                                // 这里改
                                                List<ISV.INV.barDtoData> barDtoDatas = DistinctPackageBarCodes(binDtoData.BarCodes);
                                                foreach (ISV.INV.barDtoData barDtoData in barDtoDatas)
                                                {
                                                    ic_MiscShipBinDTOData.StoreUOMQty += barDtoData.Qty;
                                                    list2.Add(barDtoData.BarCode);
                                                }
                                                //foreach (ISV.INV.barDtoData barDtoData in binDtoData.BarCodes)
                                                //{
                                                //    ic_MiscShipBinDTOData.StoreUOMQty += barDtoData.Qty;
                                                //    list2.Add(barDtoData.BarCode);
                                                //}
                                                ic_MiscShipmentLDTOData.MiscShipBins.Add(ic_MiscShipBinDTOData);
                                            }
                                        }
                                    }
                                }
                            }
                            ic_MiscShipmentDTOData.MiscShipLs.Add(ic_MiscShipmentLDTOData);
                        }
                    }
                    else
                    {
                        ISV.MiscShipISV.IC_MiscShipmentLDTOData ic_MiscShipmentLDTOData = new ISV.MiscShipISV.IC_MiscShipmentLDTOData();
                        this.SetLineValue(miscShipDocType, ic_MiscShipmentLDTOData, miscShipmentLineDTOData2);
                        if (miscShipmentLineDTOData2.BinDtos != null && miscShipmentLineDTOData2.BinDtos.Count > 0)
                        {
                            foreach (ISV.INV.binDtoData binDtoData in miscShipmentLineDTOData2.BinDtos)
                            {
                                if (!string.IsNullOrEmpty(binDtoData.BinCode))
                                {
                                    if (binDtoData.BarCodes != null && binDtoData.BarCodes.Count > 0)
                                    {
                                        ISV.MiscShipISV.IC_MiscShipBinDTOData ic_MiscShipBinDTOData = new ISV.MiscShipISV.IC_MiscShipBinDTOData();
                                        ic_MiscShipBinDTOData.BinInfo = new CBO.SCM.Bin.BinInfoData();
                                        ic_MiscShipBinDTOData.BinInfo.Bin = binDtoData.BinID;
                                        ic_MiscShipBinDTOData.BinInfo.Code = binDtoData.BinCode;
                                        ic_MiscShipBinDTOData.BinInfo.Name = binDtoData.BinName;
                                        ic_MiscShipBinDTOData.StoreUOMQty = 0m;

                                        // 这里改
                                        List<ISV.INV.barDtoData> barDtoDatas = DistinctPackageBarCodes(binDtoData.BarCodes);
                                        foreach (ISV.INV.barDtoData barDtoData in barDtoDatas)
                                        {
                                            ic_MiscShipBinDTOData.StoreUOMQty += barDtoData.Qty;
                                            list2.Add(barDtoData.BarCode);
                                        }
                                        //foreach (ISV.INV.barDtoData barDtoData in binDtoData.BarCodes)
                                        //{
                                        //    ic_MiscShipBinDTOData.StoreUOMQty += barDtoData.Qty;
                                        //    list2.Add(barDtoData.BarCode);
                                        //}
                                        ic_MiscShipmentLDTOData.MiscShipBins.Add(ic_MiscShipBinDTOData);
                                    }
                                }
                            }
                        }
                        ic_MiscShipmentDTOData.MiscShipLs.Add(ic_MiscShipmentLDTOData);
                    }
                }
                list.Add(ic_MiscShipmentDTOData);
                ISV.MiscShipISV.Proxy.CommonCreateMiscShipProxy commonCreateMiscShipProxy = new ISV.MiscShipISV.Proxy.CommonCreateMiscShipProxy();
                commonCreateMiscShipProxy.MiscShipmentDTOList = list;
                List<CBO.Pub.Controller.CommonArchiveDataDTOData> list4 = new List<CBO.Pub.Controller.CommonArchiveDataDTOData>();
                list4 = commonCreateMiscShipProxy.Do();
                if (list4.Count > 0)
                {
                    foreach (CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData in list4)
                    {
                        if (commonArchiveDataDTOData.ID > 0L)
                        {
                            InvDoc.MiscShip.MiscShipment miscShipment = InvDoc.MiscShip.MiscShipment.Finder.FindByID(commonArchiveDataDTOData.ID);
                            if (miscShipment != null)
                            {
                                str = miscShipment.DocNo;
                                if (this.DocStatus > 0)
                                {
                                    ISV.MiscShipISV.Proxy.CommonCommitMiscShipSVProxy commonCommitMiscShipSVProxy = new ISV.MiscShipISV.Proxy.CommonCommitMiscShipSVProxy();
                                    commonCommitMiscShipSVProxy.TargetOrgCode = Base.Context.LoginOrg.Code;
                                    commonCommitMiscShipSVProxy.TargetOrgName = Base.Context.LoginOrg.Name;
                                    commonCommitMiscShipSVProxy.MiscShipmentKeyList = new List<CBO.Pub.Controller.CommonArchiveDataDTOData>();
                                    CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData2 = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                                    commonArchiveDataDTOData2.ID = miscShipment.ID;
                                    commonCommitMiscShipSVProxy.MiscShipmentKeyList.Add(commonArchiveDataDTOData2);
                                    commonCommitMiscShipSVProxy.Do();
                                }
                                if (this.DocStatus > 1)
                                {
                                    if (miscShipment.MiscShipDocType != null && miscShipment.MiscShipDocType.ConfirmType != Base.Doc.ConfirmTypeEnum.ApproveFlow)
                                    {
                                        ISV.MiscShipISV.Proxy.CommonApproveMiscShipSVProxy commonApproveMiscShipSVProxy = new ISV.MiscShipISV.Proxy.CommonApproveMiscShipSVProxy();
                                        commonApproveMiscShipSVProxy.TargetOrgCode = Base.Context.LoginOrg.Code;
                                        commonApproveMiscShipSVProxy.TargetOrgName = Base.Context.LoginOrg.Name;
                                        commonApproveMiscShipSVProxy.MiscShipmentKeyList = new List<CBO.Pub.Controller.CommonArchiveDataDTOData>();
                                        CBO.Pub.Controller.CommonArchiveDataDTOData commonArchiveDataDTOData3 = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                                        commonArchiveDataDTOData3.ID = miscShipment.ID;
                                        commonApproveMiscShipSVProxy.MiscShipmentKeyList.Add(commonArchiveDataDTOData3);
                                        commonApproveMiscShipSVProxy.Do();
                                    }
                                }
                            }
                            foreach (InvDoc.MiscShip.MiscShipmentL miscShipmentL in miscShipment.MiscShipLs)
                            {
                                foreach (ISV.INV.MiscShipmentLineDTOData miscShipmentLineDTOData2 in lineDTOs)
                                {
                                    // if (miscShipmentL.ItemInfo.ItemIDKey != null && miscShipmentL.ItemInfo.ItemID.Code == miscShipmentLineDTOData2.ItemCode && ((miscShipmentL.LotInfo != null && miscShipmentLineDTOData2.LotCode != "-100" && miscShipmentLineDTOData2.LotCode != "" && miscShipmentLineDTOData2.LotCode == miscShipmentL.LotInfo.LotCode) || ((miscShipmentL.LotInfo == null || miscShipmentL.LotInfo.LotMasterKey == null) && (miscShipmentLineDTOData2.LotCode == "-100" || miscShipmentLineDTOData2.LotCode == ""))) && ((miscShipmentL.ProjectKey != null && miscShipmentLineDTOData2.ProjectCode != "-100" && miscShipmentLineDTOData2.ProjectCode != "" && miscShipmentLineDTOData2.ProjectCode == miscShipmentL.Project.Code) || (miscShipmentL.ProjectKey == null && (miscShipmentLineDTOData2.ProjectCode == "-100" || miscShipmentLineDTOData2.ProjectCode == ""))) && ((miscShipmentL.Seiban != null && miscShipmentLineDTOData2.SeibanCode != "-100" && miscShipmentLineDTOData2.SeibanCode != "" && miscShipmentLineDTOData2.SeibanCode == miscShipmentL.Seiban.SeibanNO) || (miscShipmentL.Seiban == null && (miscShipmentLineDTOData2.SeibanCode == "-100" || miscShipmentL.SeibanCode == ""))) && ((miscShipmentL.ManufacturerInfo != null && miscShipmentL.ManufacturerInfo.SupplierKey != null && miscShipmentLineDTOData2.ManufacturerCode != "-100" && miscShipmentLineDTOData2.ManufacturerCode != "" && miscShipmentLineDTOData2.ManufacturerCode == miscShipmentL.ManufacturerInfo.Supplier.Code) || ((miscShipmentL.ManufacturerInfo == null || miscShipmentL.ManufacturerInfo.SupplierKey == null) && (miscShipmentLineDTOData2.ManufacturerCode == "-100" || miscShipmentLineDTOData2.ManufacturerCode == ""))) && (miscShipmentLineDTOData2.Grade == miscShipmentL.ItemInfo.ItemGrade.Value || miscShipmentLineDTOData2.Grade < 0) && (miscShipmentLineDTOData2.Element == miscShipmentL.ItemInfo.ItemPotency.Value || miscShipmentLineDTOData2.Element < 0) && ((miscShipmentL.WhKey != null && miscShipmentLineDTOData2.WhCode == miscShipmentL.Wh.Code) || miscShipmentL.WhKey == null))
                                    if (miscShipmentL.ItemInfo.ItemIDKey != null && miscShipmentL.ItemInfo.ItemID.Code == miscShipmentLineDTOData2.ItemCode && ((miscShipmentL.LotInfo != null && miscShipmentLineDTOData2.LotCode != "-100" && miscShipmentLineDTOData2.LotCode != "" && miscShipmentLineDTOData2.LotCode == miscShipmentL.LotInfo.LotCode) || ((miscShipmentL.LotInfo == null || miscShipmentL.LotInfo.LotMasterKey == null) && (miscShipmentLineDTOData2.LotCode == "-100" || miscShipmentLineDTOData2.LotCode == ""))) && ((miscShipmentL.ProjectKey != null && miscShipmentLineDTOData2.ProjectCode != "-100" && miscShipmentLineDTOData2.ProjectCode != "" && miscShipmentLineDTOData2.ProjectCode == miscShipmentL.Project.Code) || (miscShipmentL.ProjectKey == null && (miscShipmentLineDTOData2.ProjectCode == "-100" || miscShipmentLineDTOData2.ProjectCode == ""))) && ((miscShipmentL.ManufacturerInfo != null && miscShipmentL.ManufacturerInfo.SupplierKey != null && miscShipmentLineDTOData2.ManufacturerCode != "-100" && miscShipmentLineDTOData2.ManufacturerCode != "" && miscShipmentLineDTOData2.ManufacturerCode == miscShipmentL.ManufacturerInfo.Supplier.Code) || ((miscShipmentL.ManufacturerInfo == null || miscShipmentL.ManufacturerInfo.SupplierKey == null) && (miscShipmentLineDTOData2.ManufacturerCode == "-100" || miscShipmentLineDTOData2.ManufacturerCode == ""))) && (miscShipmentLineDTOData2.Grade == miscShipmentL.ItemInfo.ItemGrade.Value || miscShipmentLineDTOData2.Grade < 0) && (miscShipmentLineDTOData2.Element == miscShipmentL.ItemInfo.ItemPotency.Value || miscShipmentLineDTOData2.Element < 0) && ((miscShipmentL.WhKey != null && miscShipmentLineDTOData2.WhCode == miscShipmentL.Wh.Code) || miscShipmentL.WhKey == null))
                                    {
                                        foreach (ISV.INV.binDtoData binDtoData in miscShipmentLineDTOData2.BinDtos)
                                        {
                                            foreach (ISV.INV.barDtoData barDtoData in binDtoData.BarCodes)
                                            {
                                                BC.CalcData.CreateBarCodeUsedInDTOData createBarCodeUsedInDTOData = new BC.CalcData.CreateBarCodeUsedInDTOData();
                                                list3.Add(createBarCodeUsedInDTOData);
                                                createBarCodeUsedInDTOData.BarCode = barDtoData.BarCode;
                                                createBarCodeUsedInDTOData.Doc = new Base.PropertyTypes.BizEntityKeyData();
                                                createBarCodeUsedInDTOData.Doc.EntityID = miscShipmentL.MiscShip.ID;
                                                createBarCodeUsedInDTOData.Doc.EntityType = miscShipmentL.MiscShip.Key.EntityType;
                                                createBarCodeUsedInDTOData.DocLine = new Base.PropertyTypes.BizEntityKeyData();
                                                createBarCodeUsedInDTOData.DocLine.EntityID = miscShipmentL.ID;
                                                createBarCodeUsedInDTOData.DocLine.EntityType = miscShipmentL.Key.EntityType;
                                                createBarCodeUsedInDTOData.Item = miscShipmentL.ItemInfo.ItemID.ID;
                                                createBarCodeUsedInDTOData.ItemCode = miscShipmentL.ItemInfo.ItemCode;
                                                createBarCodeUsedInDTOData.ItemName = miscShipmentL.ItemInfo.ItemName;
                                                createBarCodeUsedInDTOData.Org = Base.Context.LoginOrg.ID;
                                                createBarCodeUsedInDTOData.DocNo = miscShipmentL.MiscShip.DocNo;
                                                createBarCodeUsedInDTOData.DocLineNo = miscShipmentL.DocLineNo.ToString();
                                                createBarCodeUsedInDTOData.DocOrg = miscShipmentL.Org.ID;
                                                createBarCodeUsedInDTOData.CurQty = barDtoData.Qty;
                                                createBarCodeUsedInDTOData.Direct = BC.Common.DirectEnum.Shipment.Value;
                                                createBarCodeUsedInDTOData.IsUpdateWh = true;
                                            }
                                        }
                                    }
                                }
                            }
                            if (list2.Count > 0)
                            {
                                new BC.CalcData.Proxy.UpdateBarCodeStateProxy
                                {
                                    BarCodes = list2
                                }.Do();
                            }
                            if (list3.Count > 0)
                            {
                                new BC.CalcData.Proxy.CreateBarCodeUsedSVProxy
                                {
                                    CreateBCUsedInParams = list3,
                                    App = 10
                                }.Do();
                            }
                        }
                    }
                }
                session.Commit();
            }
            return "杂发单单号" + str;
        }

        private List<ISV.INV.barDtoData> DistinctPackageBarCodes(List<ISV.INV.barDtoData> barDtoDatas)
        {
            List<ISV.INV.barDtoData> r = new List<ISV.INV.barDtoData>();

            Dictionary<string, ISV.INV.barDtoData> dic = new Dictionary<string, ISV.INV.barDtoData>();
            foreach (ISV.INV.barDtoData b in barDtoDatas)
            {
                BC.BaseData.BarCode barCode = BC.BaseData.BarCode.Finder.Find("Code=@Code",
                    new UFSoft.UBF.PL.OqlParam[]
                    {
                        new UFSoft.UBF.PL.OqlParam(b.BarCode)
                    });

                string groupCode = GetGroupCode(barCode);
                if (!dic.ContainsKey(groupCode))
                {
                    dic.Add(groupCode, b);
                }
            }

            r.AddRange(dic.Values);

            return r;
        }

        private string GetGroupCode(BC.BaseData.BarCode barCode)
        {
            string groupCode = barCode.Code;

            if (barCode.Code.StartsWith("C") && barCode.Code.Length == 16)
            {
                groupCode = string.Format("{0}_{1}", barCode.Code.Substring(0, 9), barCode.Code.Substring(11, 5));
            }
            else if (barCode.Segment78 != "1")
            {
                groupCode = string.Format("{0}_{1}", barCode.Code.Substring(0, barCode.Code.Length - 5), barCode.Segment77);
            }

            return groupCode;
        }

        private ISV.MiscShipISV.IC_MiscShipmentLDTOData SetLineValue(InvDoc.MiscShip.MiscShipDocType doctype, ISV.MiscShipISV.IC_MiscShipmentLDTOData line, ISV.INV.MiscShipmentLineDTOData linedto)
        {
            line.ItemInfo = new CBO.SCM.Item.ItemInfoData();
            bool flag = CBO.Pub.Controller.BaseObject.EntitytIsSend("UFIDA.U9.CBO.SCM.Item.ItemMaster");
            string text = "Code=@Code";
            UFSoft.UBF.PL.OqlParamList oqlParamList = new UFSoft.UBF.PL.OqlParamList();
            oqlParamList.Add(new UFSoft.UBF.PL.OqlParam(linedto.ItemCode));
            if (flag)
            {
                text += " and Org.Code=@OrgCode";
                oqlParamList.Add(new UFSoft.UBF.PL.OqlParam(Base.Context.LoginOrg.Code));
            }
            CBO.SCM.Item.ItemMaster itemMaster = CBO.SCM.Item.ItemMaster.Finder.Find(text, oqlParamList.ToArray());
            if (itemMaster != null)
            {
                line.ItemInfo.ItemID = itemMaster.ID;
                line.ItemInfo.ItemCode = itemMaster.Code;
                line.ItemInfo.ItemName = itemMaster.Name;
                line.StoreUOMQty = linedto.TotalQty;
                if (this.wh != null)
                {
                    line.Wh = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                    line.Wh.ID = this.wh.ID;
                    line.Wh.Code = this.wh.Code;
                    line.Wh.Name = this.wh.Name;
                    line.StoreType = this.wh.StorageType.Value;
                }
                if (this.whman != null)
                {
                    line.WhMan = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                    line.WhMan.Code = this.whman.Code;
                    line.WhMan.ID = this.whman.ID;
                    line.WhMan.Name = this.whman.Name;
                }
                line.Project = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                line.Project.ID = linedto.ProjectID;
                line.Project.Code = linedto.ProjectCode;
                line.Project.Name = linedto.ProjectName;

                if (!string.IsNullOrEmpty(linedto.SeibanCode))
                {
                    var sourceOrgID = Base.Context.LoginOrg.ID;
                    StringBuilder ooql = new StringBuilder();
                    UFSoft.UBF.PL.OqlParamList queryList = new UFSoft.UBF.PL.OqlParamList();

                    ooql.Append("Organization=@Org");
                    queryList.Add(new UFSoft.UBF.PL.OqlParam(sourceOrgID));
                    ooql.Append(" and Profile=@Profile");
                    queryList.Add(new UFSoft.UBF.PL.OqlParam(163));
                    Base.Profile.ProfileValue seibanPV = Base.Profile.ProfileValue.Finder.Find(ooql.ToString(), queryList.ToArray());
                    if (seibanPV != null && !string.IsNullOrEmpty(seibanPV.Value))
                    {
                        long transferOrg = 0;
                        if (long.TryParse(seibanPV.Value, out transferOrg))
                        {
                            sourceOrgID = transferOrg;
                        }
                    }
                    //OqlParamList paramList = new OqlParamList();
                    //paramList.Add(new OqlParam(linedto.SeibanCode));
                    //paramList.Add(new OqlParam(sourceOrgID));
                    var findObj = CBO.SCM.Seiban.SeibanMaster.Finder.Find("SeibanNO=@Code and Org.ID=@OrgID", new OqlParam[]
                    {
                        new OqlParam(linedto.SeibanCode),
                        new OqlParam(sourceOrgID)
                    });
                    if (findObj != null)
                    {
                        line.Seiban = new UFIDA.U9.CBO.Pub.Controller.CommonArchiveDataDTOData();
                        line.Seiban.ID = findObj.ID;
                        line.Seiban.Code = findObj.SeibanNO;
                    }
                }
                //line.Seiban = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                //line.Seiban.ID = linedto.Seiban;
                //line.Seiban.Code = linedto.SeibanCode;

                line.SupplierInfo = new CBO.SCM.Supplier.SupplierMISCInfoData();
                line.SupplierInfo.Supplier = linedto.Supplier;
                line.SupplierInfo.Code = linedto.SupplierCode;
                line.SupplierInfo.Name = linedto.SupplierName;
                line.ManufacturerInfo = new CBO.SCM.Supplier.SupplierMISCInfoData();
                line.ManufacturerInfo.Supplier = linedto.Manufacturer;
                line.ManufacturerInfo.Code = linedto.ManufacturerCode;
                line.ManufacturerInfo.Name = linedto.ManufacturerName;
                line.OwnerOrg = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                line.OwnerOrg.ID = linedto.OwnerOrg;
                line.OwnerOrg.Code = linedto.OwnerOrgCode;
                line.OwnerOrg.Name = linedto.OwnerOrgName;
                if (!string.IsNullOrEmpty(linedto.BenefitWhCode))
                {
                    CBO.SCM.Warehouse.Warehouse warehouse = CBO.SCM.Warehouse.Warehouse.Finder.Find("Code =@code and Org =@orgid", new UFSoft.UBF.PL.OqlParam[]
                    {
                        new UFSoft.UBF.PL.OqlParam("code", linedto.BenefitWhCode),
                        new UFSoft.UBF.PL.OqlParam("orgid", this.benefitOrg.ID)
                    });
                    if (warehouse != null)
                    {
                        line.BenefitWh = warehouse.ID;
                    }
                }
                if (linedto.LotID > 0L)
                {
                    Lot.LotMaster lotMaster = Lot.LotMaster.Finder.FindByID(linedto.LotID);
                    if (lotMaster != null)
                    {
                        line.LotInfo = new CBO.SCM.PropertyTypes.LotInfoData();
                        line.LotInfo.LotMaster = new Base.PropertyTypes.BizEntityKeyData();
                        line.LotInfo.LotMaster.EntityID = lotMaster.ID;
                        line.LotInfo.LotCode = lotMaster.LotCode;
                        line.LotInfo.DisabledDatetime = lotMaster.InvalidTime;
                    }
                }
                else if (!string.IsNullOrEmpty(linedto.LotCode))
                {
                    Lot.LotMaster lotMaster = Lot.LotMaster.Finder.Find("LotCode =@code and Item =@item", new UFSoft.UBF.PL.OqlParam[]
                    {
                        new UFSoft.UBF.PL.OqlParam("code", linedto.LotCode),
                        new UFSoft.UBF.PL.OqlParam("item", itemMaster.ID)
                    });
                    if (lotMaster == null)
                    {
                        lotMaster = Lot.LotMaster.Finder.Find("LotCode =@code and Item.Code =@itemcode", new UFSoft.UBF.PL.OqlParam[]
                        {
                            new UFSoft.UBF.PL.OqlParam("code", linedto.LotCode),
                            new UFSoft.UBF.PL.OqlParam("itemcode", itemMaster.Code)
                        });
                    }
                    if (lotMaster != null)
                    {
                        line.LotInfo = new CBO.SCM.PropertyTypes.LotInfoData();
                        line.LotInfo.LotMaster = new Base.PropertyTypes.BizEntityKeyData();
                        line.LotInfo.LotMaster.EntityID = lotMaster.ID;
                        line.LotInfo.LotCode = lotMaster.LotCode;
                        line.LotInfo.DisabledDatetime = lotMaster.InvalidTime;
                    }
                }
                if (!string.IsNullOrEmpty(linedto.BenefitOrgCode))
                {
                    line.BenefitOrg = this.benefitOrg.ID;
                }
                if (!string.IsNullOrEmpty(linedto.BenefitDeptCode))
                {
                    CBO.HR.Department.Department department = CBO.HR.Department.Department.FindByCode(this.benefitOrg, linedto.BenefitDeptCode);
                    if (department != null)
                    {
                        line.BenefitDept = new CBO.Pub.Controller.CommonArchiveDataDTOData();
                        line.BenefitDept.Code = department.Code;
                        line.BenefitDept.Name = department.Name;
                        line.BenefitDept.ID = department.ID;
                    }
                }
                line.IsMFG = doctype.IsMFG;
                line.MiscShipBins = new List<ISV.MiscShipISV.IC_MiscShipBinDTOData>();
                return line;
            }
            throw new Exception("编码为" + linedto.ItemCode + "的料品不存在");
        }

        public Base.Organization.Organization benefitOrg = null;

        public int DocStatus = -1;

        public CBO.HR.Operator.Operators whman = null;

        public CBO.SCM.Warehouse.Warehouse wh = null;
    }

	#endregion
	
	
}