﻿namespace UFIDA.U9.Cust.Kusi.CJJ.RestApi
{
	using System;
	using System.Collections.Generic;
    using System.Data;
    using System.Runtime.CompilerServices;
    using System.Text;
    using UFIDA.U9.Base.SystemDock;
    using UFIDA.U9.BC.CalcData;
    using UFIDA.U9.CBO.SCM.Node;
    using UFIDA.U9.CBO.SCM.RMA;
    using UFIDA.U9.Complete.RCVRpt;
    using UFIDA.U9.ISV.Mobile.Common;
    using UFIDA.U9.ISV.Mobile.MO;
    using UFSoft.UBF.AopFrame;
    using UFSoft.UBF.Util.DataAccess;

    /// <summary>
    /// CreateRcvRptDocCostWithPackage partial 
    /// </summary>	
    public partial class CreateRcvRptDocCostWithPackage 
	{	
		internal BaseStrategy Select()
		{
			return new CreateRcvRptDocCostWithPackageImpementStrategy();	
		}		
	}
	
	#region  implement strategy	
	/// <summary>
	/// Impement Implement
	/// 
	/// </summary>	
	internal partial class CreateRcvRptDocCostWithPackageImpementStrategy : BaseStrategy
	{
		public CreateRcvRptDocCostWithPackageImpementStrategy() { }

		public override object Do(object obj)
		{						
			CreateRcvRptDocCostWithPackage bpObj = (CreateRcvRptDocCostWithPackage)obj;

            ISV.Mobile.MO.ResultDTOData resultDTOData = new ISV.Mobile.MO.ResultDTOData();
            resultDTOData.CreatedDocDTO = new List<ISV.Mobile.Common.CreatedDocDTOData>();
            object result;
            if (bpObj.LineDTOs == null || bpObj.LineDTOs.Count <= 0)
            {
                result = null;
            }
            else
            {
                this.isneedpick = bpObj.LineDTOs[0].IsNeedPick;
                this.IsItemBarCode = bpObj.LineDTOs[0].IsItemBarcode;

                Complete.CompleteRpt.Proxy.CreateDocByBarCodeProxy createDocByBarCodeProxy = new Complete.CompleteRpt.Proxy.CreateDocByBarCodeProxy();
                List<Complete.CompleteRpt.BarCodeInfo4DocDTOData> list = new List<Complete.CompleteRpt.BarCodeInfo4DocDTOData>();
                createDocByBarCodeProxy.IsRcvRptDoc = true;
                List<Complete.CompleteRpt.ReturnInfoData> list2 = new List<Complete.CompleteRpt.ReturnInfoData>();

                Dictionary<long, List<ISV.Mobile.MO.RcvRptDocCostDTOData>> dictionary = new Dictionary<long, List<ISV.Mobile.MO.RcvRptDocCostDTOData>>();
                foreach (ISV.Mobile.MO.RcvRptDocCostDTOData rcvRptDocCostDTOData in bpObj.LineDTOs)
                {
                    if (dictionary.ContainsKey(rcvRptDocCostDTOData.DocID))
                    {
                        dictionary[rcvRptDocCostDTOData.DocID].Add(rcvRptDocCostDTOData);
                    }
                    else
                    {
                        List<ISV.Mobile.MO.RcvRptDocCostDTOData> list3 = new List<ISV.Mobile.MO.RcvRptDocCostDTOData>();
                        list3.Add(rcvRptDocCostDTOData);
                        dictionary.Add(rcvRptDocCostDTOData.DocID, list3);
                    }
                }

                Dictionary<long, decimal> moQty = new Dictionary<long, decimal>();
                Dictionary<long, decimal> moScraptQty = new Dictionary<long, decimal>();
                foreach (KeyValuePair<long, List<ISV.Mobile.MO.RcvRptDocCostDTOData>> keyValuePair in dictionary)
                {
                    if (keyValuePair.Value != null && keyValuePair.Value.Count > 0)
                    {
                        if (IsPackage(keyValuePair.Value[0].BarCode))
                        {
                            GetPackageQty(moQty, moScraptQty, keyValuePair);
                        }
                        else
                        {
                            GetQty(moQty, moScraptQty, keyValuePair);
                        }
                    }
                }

                foreach (KeyValuePair<long, List<ISV.Mobile.MO.RcvRptDocCostDTOData>> keyValuePair in dictionary)
                {
                    Complete.CompleteRpt.BarCodeInfo4DocDTOData barCodeInfo4DocDTOData = new Complete.CompleteRpt.BarCodeInfo4DocDTOData();
                    List<ISV.Mobile.MO.RcvRptDocCostDTOData> value = keyValuePair.Value;
                    barCodeInfo4DocDTOData.MO = keyValuePair.Key;
                    Complete.RCVRpt.RcvRptDocType rcvRptDocType = null;
                    if (value != null && value.Count > 0)
                    {
                        if (value[0].RcvRptDocTypeCode != null && !value[0].RcvRptDocTypeCode.Equals(string.Empty))
                        {
                            rcvRptDocType = RcvRptDocType.Finder.Find(string.Concat(new string[]
                            {
                                "Org=",
                                Base.Context.LoginOrg.ID.ToString(),
                                " and Code='",
                                value[0].RcvRptDocTypeCode,
                                "'"
                            }), new UFSoft.UBF.PL.OqlParam[0]);
                        }
                    }

                    // 设置Qty和ScraptQty
                    if (moQty.ContainsKey(barCodeInfo4DocDTOData.MO))
                    {
                        barCodeInfo4DocDTOData.Qty = moQty[barCodeInfo4DocDTOData.MO];
                    }
                    else
                    {
                        barCodeInfo4DocDTOData.Qty = 0;
                    }

                    if (moScraptQty.ContainsKey(barCodeInfo4DocDTOData.MO))
                    {
                        barCodeInfo4DocDTOData.ScraptQty = moScraptQty[barCodeInfo4DocDTOData.MO];
                    }
                    else
                    {
                        barCodeInfo4DocDTOData.ScraptQty = 0;
                    }

                    //
                    foreach (ISV.Mobile.MO.RcvRptDocCostDTOData rcvRptDocCostDTOData2 in value)
                    {
                        if (rcvRptDocType != null)
                        {
                            barCodeInfo4DocDTOData.RcvRptDocType = rcvRptDocType.ID;
                        }
                        // barCodeInfo4DocDTOData.Qty += rcvRptDocCostDTOData2.QulifiedQty;
                        // barCodeInfo4DocDTOData.ScraptQty += rcvRptDocCostDTOData2.ScrapQty;
                        if (rcvRptDocCostDTOData2.WhID > 0L)
                        {
                            barCodeInfo4DocDTOData.Wh = rcvRptDocCostDTOData2.WhID;
                        }
                        else
                        {
                            MO.MO.MO mo = MO.MO.MO.Finder.FindByID(keyValuePair.Key);
                            if (mo == null || !(mo.SCVWhKey != null))
                            {
                                throw new Exception("存储地点不能为空，请录入");
                            }
                            barCodeInfo4DocDTOData.Wh = mo.SCVWh.ID;
                        }
                        if (rcvRptDocCostDTOData2.BinID > 0L)
                        {
                            barCodeInfo4DocDTOData.Bin = rcvRptDocCostDTOData2.BinID;
                        }
                    }
                    list.Add(barCodeInfo4DocDTOData);
                }
                createDocByBarCodeProxy.BarCodeInfo4Doc = list;
                if (list != null && list.Count > 0)
                {
                    list2 = createDocByBarCodeProxy.Do();
                }
                if (list2 != null && list2.Count > 0)
                {
                    foreach (Complete.CompleteRpt.ReturnInfoData returnInfoData in list2)
                    {
                        if (returnInfoData.ErrorMessage != null)
                        {
                            resultDTOData.ErrorMessage += returnInfoData.ErrorMessage;
                        }

                        if (!string.IsNullOrEmpty(resultDTOData.ErrorMessage))
                        {
                            throw new Exception(resultDTOData.ErrorMessage);
                        }

                        resultDTOData.DocID = returnInfoData.ReturnDocID;
                        Complete.RCVRpt.RcvRptDoc newdoc = Complete.RCVRpt.RcvRptDoc.Finder.FindByID(returnInfoData.ReturnDocID);

                        if (this.IsItemBarCode)
                        {
                            this.SetBarCodeUsedDTO(newdoc, bpObj.LineDTOs);
                        }

                        if (this.isneedpick)
                        {
                            ISV.Mobile.Common.CreatedDocDTOData item = this.SetPickRtn(newdoc, bpObj.LineDTOs);
                            resultDTOData.CreatedDocDTO.Add(item);
                        }
                    }

                    this.UpdateBarCodeState();
                    this.CreateBarCodeUsed();
                }
                result = resultDTOData;
            }
            return result;
        }

        private bool IsPackage(string code)
        {
            BC.BaseData.BarCode barCode = BC.BaseData.BarCode.Finder.Find("Code=@Code",
                new UFSoft.UBF.PL.OqlParam[]
                {
                    new UFSoft.UBF.PL.OqlParam(code)
                });

            if (barCode != null)
            {
                if (barCode.Segment78 != null && barCode.Segment78 != "1")
                {
                    return true;
                }
            }

            return false;
        }

        private void GetQty(Dictionary<long, decimal> moQty, Dictionary<long, decimal> moScraptQty, KeyValuePair<long, List<ISV.Mobile.MO.RcvRptDocCostDTOData>> keyValuePair)
        {
            decimal qty = 0;
            decimal scraptQty = 0;
            foreach (var value in keyValuePair.Value)
            {
                qty += value.QulifiedQty;
                scraptQty += value.ScrapQty;
            }

            moQty.Add(keyValuePair.Key, qty);
            moScraptQty.Add(keyValuePair.Key, scraptQty);
        }

        private void GetPackageQty(Dictionary<long, decimal> moQty, Dictionary<long, decimal> moScraptQty, KeyValuePair<long, List<ISV.Mobile.MO.RcvRptDocCostDTOData>> keyValuePair)
        {
            decimal commonQty = 1;
            decimal scraptQty = 0;
            if (keyValuePair.Value != null && keyValuePair.Value.Count > 0)
            {
                StringBuilder scrapCodes = new StringBuilder();
                Dictionary<string, RcvRptDocCostDTOData> tmpDic = new Dictionary<string, RcvRptDocCostDTOData>();
                foreach (var value in keyValuePair.Value)
                {
                    if (value.ScrapQty > 0)
                    {
                        scrapCodes.AppendFormat("{0},", value.BarCode);
                    }

                    if (!tmpDic.ContainsKey(value.BarCode))
                    {
                        tmpDic.Add(value.BarCode, value);
                    }
                }

                if (scrapCodes.Length > 0)
                {
                    DataParamList dataParams = new DataParamList
                    {
                        DataParamFactory.CreateInput("BarCodes", scrapCodes.ToString(0, scrapCodes.Length - 1), DbType.String),
                        DataParamFactory.CreateInput("OrgCode", Base.Context.LoginOrg.Code, DbType.String)
                    };

                    DataAccessor.RunSP("SP_Cust_PDA_GetScrapQty", dataParams, out DataSet dataSet);
                    if (dataSet != null && dataSet.Tables.Count > 0 && dataSet.Tables[0].Rows.Count > 0)
                    {
                        scraptQty = Convert.ToDecimal(dataSet.Tables[0].Rows[0][0]);
                    }

                    DataAccessor.RunSP("SP_Cust_PDA_GetPackageBarCodes", dataParams, out dataSet);
                    if (dataSet != null && dataSet.Tables.Count > 0 && dataSet.Tables[0].Rows.Count > 0)
                    {
                        for (int i = 0; i < dataSet.Tables[0].Rows.Count; i++)
                        {
                            string code = Convert.ToString(dataSet.Tables[0].Rows[i][0]);
                            if (tmpDic.ContainsKey(code) && tmpDic[code].ScrapQty == 0)
                            {
                                (tmpDic[code].ScrapQty, tmpDic[code].QulifiedQty) = (tmpDic[code].QulifiedQty, tmpDic[code].ScrapQty);
                            }
                        }
                    }
                }

                BC.BaseData.BarCode barCode = BC.BaseData.BarCode.Finder.Find("Code=@Code",
                new UFSoft.UBF.PL.OqlParam[]
                {
                    new UFSoft.UBF.PL.OqlParam(keyValuePair.Value[0].BarCode)
                });

                if (barCode != null)
                {
                    if (decimal.TryParse(barCode.Segment78, out decimal tmpQty))
                    {
                        commonQty = tmpQty;
                    }
                }
            }

            moQty.Add(keyValuePair.Key, keyValuePair.Value.Count / commonQty - scraptQty);
            moScraptQty.Add(keyValuePair.Key, scraptQty);
        }

        private void UpdateBarCodeState()
        {
            if (this.barCodes.Count > 0)
            {
                new BC.CalcData.Proxy.UpdateBarCodeStateProxy
                {
                    BarCodes = this.barCodes
                }.Do();
            }
        }

        private void CreateBarCodeUsed()
        {
            if (this.usedtos.Count > 0)
            {
                new BC.CalcData.Proxy.CreateBarCodeUsedSVProxy
                {
                    CreateBCUsedInParams = this.usedtos,
                    App = 7
                }.Do();
            }
        }

        private void SetBarCodeUsedDTO(RcvRptDoc newdoc, List<RcvRptDocCostDTOData> linedtos)
        {
            foreach (RcvRptDocLine rcvRptDocLine in newdoc.RcvRptDocLines)
            {
                foreach (RcvRptDocCostDTOData rcvRptDocCostDTOData in linedtos)
                {
                    if (rcvRptDocLine.ItemKey != null && rcvRptDocLine.Item.Code == rcvRptDocCostDTOData.ItemCode && ((rcvRptDocLine.RcvLotMasterKey != null && !string.IsNullOrEmpty(rcvRptDocCostDTOData.LotCode) && rcvRptDocCostDTOData.LotCode == rcvRptDocLine.RcvLotMaster.LotCode) || (rcvRptDocLine.RcvLotMasterKey == null && string.IsNullOrEmpty(rcvRptDocCostDTOData.LotCode))) && ((rcvRptDocLine.ProjectKey != null && !string.IsNullOrEmpty(rcvRptDocCostDTOData.ProjectCode) && rcvRptDocCostDTOData.ProjectCode == rcvRptDocLine.Project.Code) || (rcvRptDocLine.ProjectKey == null && string.IsNullOrEmpty(rcvRptDocCostDTOData.ProjectCode))) && ((rcvRptDocLine.RcvSeibanKey != null && !string.IsNullOrEmpty(rcvRptDocCostDTOData.SeibanCode) && rcvRptDocCostDTOData.SeibanCode == rcvRptDocLine.RcvSeiban.SeibanNO) || (rcvRptDocLine.RcvSeiban == null && string.IsNullOrEmpty(rcvRptDocCostDTOData.SeibanCode))) && ((rcvRptDocLine.ItemVersion != null && !string.IsNullOrEmpty(rcvRptDocCostDTOData.ItemVersion) && rcvRptDocCostDTOData.ItemVersion == rcvRptDocLine.ItemVersion.Version) || (rcvRptDocLine.ItemVersion == null && string.IsNullOrEmpty(rcvRptDocCostDTOData.ItemVersion))) && (rcvRptDocCostDTOData.Grade == rcvRptDocLine.Grade.Value || rcvRptDocCostDTOData.Grade < 0) && (rcvRptDocCostDTOData.Element == rcvRptDocLine.Element.Value || rcvRptDocCostDTOData.Element < 0) && (!(rcvRptDocLine.WhKey != null) || string.IsNullOrEmpty(rcvRptDocCostDTOData.WhCode) || !(rcvRptDocCostDTOData.WhCode != rcvRptDocLine.Wh.Code)))
                    {
                        CreateBarCodeUsedInDTOData createBarCodeUsedInDTOData = new CreateBarCodeUsedInDTOData();
                        if (!string.IsNullOrEmpty(rcvRptDocCostDTOData.BarCode))
                        {
                            this.barCodes.Add(rcvRptDocCostDTOData.BarCode);
                        }
                        createBarCodeUsedInDTOData = this.SetBarCodeUseDtoValue(rcvRptDocLine, rcvRptDocCostDTOData);
                        if (rcvRptDocLine.StorageType == CBO.Enums.StorageTypeEnum.Useable)
                        {
                            createBarCodeUsedInDTOData.CurQty = rcvRptDocCostDTOData.QulifiedQty;
                        }
                        else
                        {
                            createBarCodeUsedInDTOData.CurQty = rcvRptDocCostDTOData.ScrapQty;
                        }
                        this.usedtos.Add(createBarCodeUsedInDTOData);
                    }
                }
            }
        }

        private CreateBarCodeUsedInDTOData SetBarCodeUseDtoValue(RcvRptDocLine line, RcvRptDocCostDTOData linedto)
        {
            return new CreateBarCodeUsedInDTOData
            {
                BarCode = linedto.BarCode,
                Doc = new UFIDA.U9.Base.PropertyTypes.BizEntityKeyData()
                {
                    EntityID = line.RcvRptDoc.ID,
                    EntityType = line.RcvRptDoc.Key.EntityType
                },
                DocLine = new UFIDA.U9.Base.PropertyTypes.BizEntityKeyData()
                {
                    EntityID = line.ID,
                    EntityType = line.Key.EntityType
                },
                Item = line.Item.ID,
                ItemCode = line.Item.Code,
                ItemName = line.Item.Name,
                Org = Base.Context.LoginOrg.ID,
                DocNo = line.RcvRptDoc.DocNo,
                DocLineNo = line.LineNum.ToString(),
                DocOrg = line.RcvRptDoc.Org.ID,
                Direct = BC.Common.DirectEnum.Rcv.Value,
                IsUpdateWh = false
            };
        }

        private CreatedDocDTOData SetPickRtn(RcvRptDoc newdoc, List<RcvRptDocCostDTOData> linedtos)
        {
            CreatedDocDTOData createdDocDTOData = new CreatedDocDTOData();
            createdDocDTOData.DocID = newdoc.ID;
            createdDocDTOData.DocNo = newdoc.DocNo;
            createdDocDTOData.Lines = new List<CreatedLineDTOData>();
            foreach (RcvRptDocLine rcvRptDocLine in newdoc.RcvRptDocLines)
            {
                CreatedLineDTOData createdLineDTOData = new CreatedLineDTOData();
                createdLineDTOData.DocLineID = rcvRptDocLine.ID;
                createdLineDTOData.DocLineNo = rcvRptDocLine.LineNum;
                createdLineDTOData.BarCodeList = new List<ItemBarCodelineUseDTOData>();
                if (this.IsItemBarCode)
                {
                    foreach (RcvRptDocCostDTOData rcvRptDocCostDTOData in linedtos)
                    {
                        if (rcvRptDocLine.ItemKey != null && rcvRptDocLine.Item.Code == rcvRptDocCostDTOData.ItemCode && ((rcvRptDocLine.ProjectKey != null && !string.IsNullOrEmpty(rcvRptDocCostDTOData.ProjectCode) && rcvRptDocCostDTOData.ProjectCode == rcvRptDocLine.Project.Code) || (rcvRptDocLine.ProjectKey == null && string.IsNullOrEmpty(rcvRptDocCostDTOData.ProjectCode))) && ((rcvRptDocLine.RcvSeibanKey != null && !string.IsNullOrEmpty(rcvRptDocCostDTOData.SeibanCode) && rcvRptDocCostDTOData.SeibanCode == rcvRptDocLine.RcvSeiban.SeibanNO) || (rcvRptDocLine.RcvSeiban == null && string.IsNullOrEmpty(rcvRptDocCostDTOData.SeibanCode))) && ((rcvRptDocLine.ItemVersion != null && !string.IsNullOrEmpty(rcvRptDocCostDTOData.ItemVersion) && rcvRptDocCostDTOData.ItemVersion == rcvRptDocLine.ItemVersion.Version) || (rcvRptDocLine.ItemVersion == null && string.IsNullOrEmpty(rcvRptDocCostDTOData.ItemVersion))) && (rcvRptDocCostDTOData.Grade == rcvRptDocLine.Grade.Value || rcvRptDocCostDTOData.Grade < 0) && (rcvRptDocCostDTOData.Element == rcvRptDocLine.Element.Value || rcvRptDocCostDTOData.Element < 0) && rcvRptDocLine.WhKey != null && !string.IsNullOrEmpty(rcvRptDocCostDTOData.WhCode) && rcvRptDocCostDTOData.WhCode == rcvRptDocLine.Wh.Code)
                        {
                            if ((rcvRptDocLine.RcvLotMasterKey != null && !string.IsNullOrEmpty(rcvRptDocCostDTOData.LotCode) && rcvRptDocCostDTOData.LotCode == rcvRptDocLine.RcvLotMaster.LotCode) || (rcvRptDocLine.RcvLotMasterKey == null && string.IsNullOrEmpty(rcvRptDocCostDTOData.LotCode)))
                            {
                                if (rcvRptDocLine.MO != null && rcvRptDocLine.MO.ID == rcvRptDocCostDTOData.DocID)
                                {
                                    ItemBarCodelineUseDTOData itemBarCodelineUseDTOData = new ItemBarCodelineUseDTOData();
                                    itemBarCodelineUseDTOData.BarCode = rcvRptDocCostDTOData.BarCode;
                                    if (rcvRptDocLine.StorageType == CBO.Enums.StorageTypeEnum.Wasted)
                                    {
                                        itemBarCodelineUseDTOData.Qty = rcvRptDocCostDTOData.ScrapQty;
                                    }
                                    else
                                    {
                                        itemBarCodelineUseDTOData.Qty = rcvRptDocCostDTOData.QulifiedQty;
                                    }
                                    createdLineDTOData.BarCodeList.Add(itemBarCodelineUseDTOData);
                                }
                            }
                            else if (rcvRptDocLine.RcvLotMasterKey != null && string.IsNullOrEmpty(rcvRptDocCostDTOData.LotCode))
                            {
                                if (!string.IsNullOrEmpty(rcvRptDocLine.RcvLotMaster.DocNo) && rcvRptDocLine.RcvLotMaster.DocNo == rcvRptDocLine.RcvRptDoc.DocNo)
                                {
                                    if (rcvRptDocLine.MO != null && rcvRptDocLine.MO.ID == rcvRptDocCostDTOData.DocID)
                                    {
                                        ItemBarCodelineUseDTOData itemBarCodelineUseDTOData = new ItemBarCodelineUseDTOData();
                                        itemBarCodelineUseDTOData.BarCode = rcvRptDocCostDTOData.BarCode;
                                        if (rcvRptDocLine.StorageType == CBO.Enums.StorageTypeEnum.Wasted)
                                        {
                                            itemBarCodelineUseDTOData.Qty = rcvRptDocCostDTOData.ScrapQty;
                                        }
                                        else
                                        {
                                            itemBarCodelineUseDTOData.Qty = rcvRptDocCostDTOData.QulifiedQty;
                                        }
                                        createdLineDTOData.BarCodeList.Add(itemBarCodelineUseDTOData);
                                    }
                                }
                            }
                        }
                    }
                }
                createdDocDTOData.Lines.Add(createdLineDTOData);
            }
            return createdDocDTOData;
        }

        public List<string> barCodes = new List<string>();

        public List<CreateBarCodeUsedInDTOData> usedtos = new List<CreateBarCodeUsedInDTOData>();

        public bool IsItemBarCode = false;

        public bool isneedpick = false;
    }

	#endregion
	
	
}