﻿namespace UFIDA.U9.Cust.Kusi.CJJ.RestApi
{
	using System;
	using System.Collections.Generic;
	using System.Data;
	using System.Data.SqlClient;
	using System.Text;
	using UFIDA.U9.Base.Profile;
	using UFIDA.U9.BC.Common;
	using UFIDA.U9.MO.ManufactureSimu;
	using UFSoft.UBF.AopFrame;	
	using UFSoft.UBF.Util.Context;
	using UFSoft.UBF.Util.DataAccess;

	/// <summary>
	/// GetBarCodeExtInfoSV partial 
	/// </summary>	
	public partial class GetBarCodeExtInfoSV 
	{	
		internal BaseStrategy Select()
		{
			return new GetBarCodeExtInfoSVImpementStrategy();	
		}		
	}
	
	#region  implement strategy	
	/// <summary>
	/// Impement Implement
	/// 
	/// </summary>	
	internal partial class GetBarCodeExtInfoSVImpementStrategy : BaseStrategy
	{
		public GetBarCodeExtInfoSVImpementStrategy() { }

		public override object Do(object obj)
		{						
			GetBarCodeExtInfoSV bpObj = (GetBarCodeExtInfoSV)obj;

			List<ExtInfoDTOData> result = new List<ExtInfoDTOData>();
			foreach (var dto in bpObj.BarCodes)
			{
				BC.BaseData.BarCode entity = BC.BaseData.BarCode.Finder.Find("Code=@code",
					new UFSoft.UBF.PL.OqlParam[]
					{
						new UFSoft.UBF.PL.OqlParam(dto.BarCode)
					});
				if (entity != null && entity.BarCodeType == BarCodeTypeEnum.ItemBarCode)
				{
					result.Add(GetExtInfo(entity));
				}

            }

			return result;
		}
		
		private ExtInfoDTOData GetExtInfo(BC.BaseData.BarCode entity)
		{
			ExtInfoDTOData data = new ExtInfoDTOData
			{
				BarCode = entity.Code,
				BarCodeType = entity.BarCodeType.Value,
				Qty = entity.Qty,
				WhQty = entity.WhQty,
				PartName = GetPartName(entity),
				Packages = GetPackages(entity)
			};

			GetStorageInfo(data, entity);

            return data;
		}

		private string GetPartName(BC.BaseData.BarCode entity)
		{
			if (entity.Segment78 == string.Empty || Convert.ToInt64(entity.Segment78) == 1)
			{
                CBO.SCM.Item.ItemMaster itemMaster = CBO.SCM.Item.ItemMaster.Finder.Find("Code=@Code", new UFSoft.UBF.PL.OqlParam[] { new UFSoft.UBF.PL.OqlParam(entity.Segment1) });
                if (itemMaster != null)
                {
                    return itemMaster.Name;
                }
            }
			else
			{
				return entity.Segment80;
			}

			return "";
		}

		private List<PackageInfoDTOData> GetPackages(BC.BaseData.BarCode entity)
		{
			string packageCode = GetPackageCode(entity.Code);
            List<PackageInfoDTOData> packages = new List<PackageInfoDTOData>();

			string sql = string.Format("select Code, Segment77, Segment78, Segment79, Segment80 from BC_BarCode where Segment77='{0}' and case when (substring(Code, 1, 1)='C' and len(Code)=16) then substring(Code, 1, 9)+'_'+substring(Code, 12, 5) else case when len(Code)>5 then substring(Code, 1, len(Code) - 5) else '' end end = '{1}'", entity.Segment77, packageCode);
			IDataReader reader;
			DataAccessor.RunSQL(DataAccessor.GetConn(), sql, null, out reader);
			if (reader != null)
			{
				while(reader.Read())
				{
					IDataRecord record = (IDataRecord)reader;

					PackageInfoDTOData packageInfo = new PackageInfoDTOData();

					packageInfo.BarCode = record.GetString(0);
					packageInfo.PackageGroup = record.GetString(2) == "1" ? "-1" : record.GetString(1);
					packageInfo.PackageSize = record.GetString(2);
                    packageInfo.PackageSeq = record.GetString(3);
                    packageInfo.PartName = record.GetString(4);

                    packageInfo.PackageCode = packageCode;

					packages.Add(packageInfo);

				}
            }

            return packages;
        }

		private string GetPackageCode(string code)
		{
			if (code.StartsWith("C") && code.Length == 16)
			{
				return string.Format("{0}_{1}", code.Substring(0, 9), code.Substring(11,5));
			}
			else
			{
				if (code.Length > 5)
				{
					return code.Substring(0, code.Length - 5);
				}
			}

			return code;
		}

		private void GetStorageInfo(ExtInfoDTOData data, BC.BaseData.BarCode entity)
		{
			if (entity.WhQty > 0)
			{
				BC.BaseData.BarCodeUsed barCodeUsed = BC.BaseData.BarCodeUsed.Finder.Find("BarCode=@BarCode and (Direct=1 or CopyOfBarCodeApp=11) order by UseDate desc",
					new UFSoft.UBF.PL.OqlParam[]
					{
						new UFSoft.UBF.PL.OqlParam(entity.Code)
					});
				if (barCodeUsed != null)
				{
					var result = new GetBarCodeUsedWhBinInfoSV()
					{
						BarCodeUsedIDs = new List<long>() { barCodeUsed.ID }
					}.Do();

					if (result.Count > 0)
					{
						data.WhID = result[0].WhID;
						data.WhCode = result[0].WhCode;
						data.WhName = result[0].WhName;
						data.BinID = result[0].BinID;
						data.BinCode = result[0].BinCode;
						data.BinName = result[0].BinName;
						data.BinBarCode = result[0].BinBarCode;
						data.BinOrgCode = result[0].BinOrgCode;
					}
                }
            }
		}
	}

	#endregion
	
	
}