﻿namespace UFIDA.U9.Cust.Kusi.CJJ.RestApi
{
	using System;
	using System.Collections.Generic;
	using System.Text; 
	using UFSoft.UBF.AopFrame;	
	using UFSoft.UBF.Util.Context;

	/// <summary>
	/// POToRcvBCSVWithPackage partial 
	/// </summary>	
	public partial class POToRcvBCSVWithPackage 
	{	
		internal BaseStrategy Select()
		{
			return new POToRcvBCSVWithPackageImpementStrategy();	
		}		
	}
	
	#region  implement strategy	
	/// <summary>
	/// Impement Implement
	/// 
	/// </summary>	
	internal partial class POToRcvBCSVWithPackageImpementStrategy : BaseStrategy
	{
		public POToRcvBCSVWithPackageImpementStrategy() { }

		public override object Do(object obj)
		{						
			POToRcvBCSVWithPackage bpObj = (POToRcvBCSVWithPackage)obj;

            List<ISV.Mobile.Common.CreatedDocDTOData> result = new List<ISV.Mobile.Common.CreatedDocDTOData>();

            List<long> rcvkeys = this.CreateDoc(bpObj.SrcDocBarCodes);
            this.UpdateBarCodeState(bpObj.SrcDocBarCodes);
            result = this.CreateItemBarCodeUseDetail(bpObj.SrcDocBarCodes, rcvkeys);

            return result;
        }

        private List<long> CreateDoc(List<ISV.Mobile.PM.POToRcvBCDTOData> srcdocbarcodes)
        {
            List<long> result = new List<long>();
            if (srcdocbarcodes == null || srcdocbarcodes.Count == 0)
            {
                throw new UFSoft.UBF.Util.Exceptions.ApplicationExceptionBase("传入的建单DTO不能为空");
            }
            List<ISV.RCV.DTO.POToRcvTransDTOData> list = new List<ISV.RCV.DTO.POToRcvTransDTOData>();
            List<ISV.Mobile.PM.POToRcvBCDTOData> r = GetRealQty(srcdocbarcodes);
            foreach (ISV.Mobile.PM.POToRcvBCDTOData potoRcvBCDTOData in r)
            {
                this.GetPOToRcvDTOs(potoRcvBCDTOData.SrcDocDetails, list);
            }
            if (list.Count > 0)
            {
                result = new ISV.RCV.Proxy.CeateReceivementFromPOSRVProxy
                {
                    POToRcvTransDTOs = list
                }.Do();
            }
            return result;
        }

        private List<ISV.Mobile.PM.POToRcvBCDTOData> GetRealQty(List<ISV.Mobile.PM.POToRcvBCDTOData> srcdocbarcodes)
        {
            List<ISV.Mobile.PM.POToRcvBCDTOData> r = new List<ISV.Mobile.PM.POToRcvBCDTOData>();

            Dictionary<string, ISV.Mobile.PM.POToRcvBCDTOData> group = new Dictionary<string, ISV.Mobile.PM.POToRcvBCDTOData>();
            // Dictionary<string, ISV.Mobile.PM.POToRcvBCDTOData> unPackage = new Dictionary<string, ISV.Mobile.PM.POToRcvBCDTOData>();
            foreach(var dto in srcdocbarcodes)
            {
                BC.BaseData.BarCode barCode = BC.BaseData.BarCode.Finder.Find("Code=@Code",
                    new UFSoft.UBF.PL.OqlParam[]
                    {
                        new UFSoft.UBF.PL.OqlParam(dto.BarCode)
                    });

                if (barCode != null)
                {
                    if (barCode.Segment78 == null || barCode.Segment78 == "1")
                    {
                        r.Add(dto);
                        //if (!unPackage.ContainsKey(string.Format("{0}_{1}", barCode.Code.Substring(0, barCode.Code.Length - 5), barCode.Segment77)))
                        //{
                        //    unPackage.Add(barCode.Code.Substring(0, barCode.Code.Length - 5), dto);
                        //}
                    }
                    else
                    {
                        string key = barCode.Code.StartsWith("C") && barCode.Code.Length == 16 ? string.Format("{0}_{1}", barCode.Code.Substring(0, 9), barCode.Code.Substring(11, 5)) : string.Format("{0}_{1}", barCode.Code.Substring(0, barCode.Code.Length - 5), barCode.Segment77);
                        if (!group.ContainsKey(key))
                        {
                            group.Add(key, dto);
                        }
                    }
                }
            }

            // r.AddRange(unPackage.Values);
            r.AddRange(group.Values);

            return r;
        }

        private void GetPOToRcvDTOs(List<ISV.Mobile.PM.POToRcvBCDetailDTOData> docdetails, List<ISV.RCV.DTO.POToRcvTransDTOData> potorcvdtos)
        {
            foreach (ISV.Mobile.PM.POToRcvBCDetailDTOData potoRcvBCDetailDTOData in docdetails)
            {
                if (potoRcvBCDetailDTOData.SrcDocKey > 0L)
                {
                    bool flag = false;
                    foreach (ISV.RCV.DTO.POToRcvTransDTOData potoRcvTransDTOData in potorcvdtos)
                    {
                        if (potoRcvTransDTOData.POShipLineKey == potoRcvBCDetailDTOData.SrcDocKey)
                        {
                            flag = true;
                            potoRcvTransDTOData.TransQty.Amount1 += potoRcvBCDetailDTOData.Qty;
                        }
                    }
                    if (!flag)
                    {
                        ISV.RCV.DTO.POToRcvTransDTOData potoRcvTransDTOData2 = new ISV.RCV.DTO.POToRcvTransDTOData();
                        potoRcvTransDTOData2.BusinessDate = DateTime.Now.Date;
                        potoRcvTransDTOData2.POShipLineKey = potoRcvBCDetailDTOData.SrcDocKey;
                        potoRcvTransDTOData2.TransQty = new CBO.DTOs.DoubleQuantityData();
                        potoRcvTransDTOData2.TransQty.Amount1 = potoRcvBCDetailDTOData.Qty;
                        potoRcvTransDTOData2.RcvLineInfoDTO = new ISV.RCV.DTO.RcvLineInfoDTOData();
                        if (potoRcvBCDetailDTOData.WH > 0L)
                        {
                            potoRcvTransDTOData2.RcvLineInfoDTO.Wh = potoRcvBCDetailDTOData.WH;
                        }
                        CBO.HR.Operator.Operators currentDepotOperators = CBO.HR.Operator.Operators.GetCurrentDepotOperators();
                        if (currentDepotOperators != null)
                        {
                            potoRcvTransDTOData2.RcvLineInfoDTO.WhMan = currentDepotOperators.Key.ID;
                        }
                        potorcvdtos.Add(potoRcvTransDTOData2);
                    }
                }
            }
        }

        private void UpdateBarCodeState(List<ISV.Mobile.PM.POToRcvBCDTOData> srcdocbarcodes)
        {
            List<string> list = new List<string>();
            foreach (ISV.Mobile.PM.POToRcvBCDTOData potoRcvBCDTOData in srcdocbarcodes)
            {
                if (!potoRcvBCDTOData.IsItemCode)
                {
                    list.Add(potoRcvBCDTOData.BarCode);
                }
            }
            if (list.Count > 0)
            {
                new BC.CalcData.Proxy.UpdateBarCodeStateProxy
                {
                    BarCodes = list
                }.Do();
            }
        }

        private List<ISV.Mobile.Common.CreatedDocDTOData> CreateItemBarCodeUseDetail(List<ISV.Mobile.PM.POToRcvBCDTOData> srcdocbarcodes, List<long> rcvkeys)
        {
            List<ISV.Mobile.Common.CreatedDocDTOData> list = new List<ISV.Mobile.Common.CreatedDocDTOData>();
            Dictionary<long, ISV.Mobile.Common.CreatedDocDTOData> dictionary = new Dictionary<long, ISV.Mobile.Common.CreatedDocDTOData>();
            List<BC.CalcData.CreateBarCodeUsedInDTOData> list2 = new List<BC.CalcData.CreateBarCodeUsedInDTOData>();
            string text = "RcvLine__IDList";
            PM.Rcv.Receivement.EntityList entityList = PM.Rcv.Receivement.Finder.FindAll(string.Format("ID in(@{0})", text), new UFSoft.UBF.PL.OqlParam[]
            {
                new UFSoft.UBF.PL.OqlParam(text, UFSoft.UBF.Sys.Database.SysUtils.ToXml(UFSoft.UBF.Sys.Database.SysUtils.CreateIDTable(rcvkeys)))
            });
            foreach (PM.Rcv.Receivement receivement in entityList)
            {
                ISV.Mobile.Common.CreatedDocDTOData createdDocDTOData = new ISV.Mobile.Common.CreatedDocDTOData();
                createdDocDTOData.DocNo = receivement.DocNo;
                createdDocDTOData.DocID = receivement.ID;
                dictionary.Add(receivement.ID, createdDocDTOData);
                list.Add(dictionary[receivement.ID]);
            }
            foreach (ISV.Mobile.PM.POToRcvBCDTOData potoRcvBCDTOData in srcdocbarcodes)
            {
                if (potoRcvBCDTOData.IsItemCode)
                {
                    foreach (ISV.Mobile.PM.POToRcvBCDetailDTOData potoRcvBCDetailDTOData in potoRcvBCDTOData.SrcDocDetails)
                    {
                        foreach (PM.Rcv.Receivement receivement in entityList)
                        {
                            foreach (PM.Rcv.RcvLine rcvLine in receivement.RcvLines)
                            {
                                if (rcvLine.SrcDoc.SrcDocSubLine != null && rcvLine.SrcDoc.SrcDocSubLine.EntityID == potoRcvBCDetailDTOData.SrcDocKey)
                                {
                                    BC.CalcData.CreateBarCodeUsedInDTOData createBarCodeUsedInDTOData = new BC.CalcData.CreateBarCodeUsedInDTOData();
                                    list2.Add(createBarCodeUsedInDTOData);
                                    createBarCodeUsedInDTOData.BarCode = potoRcvBCDTOData.BarCode;
                                    createBarCodeUsedInDTOData.Doc = new Base.PropertyTypes.BizEntityKeyData();
                                    createBarCodeUsedInDTOData.Doc.EntityID = receivement.ID;
                                    createBarCodeUsedInDTOData.Doc.EntityType = receivement.Key.EntityType;
                                    createBarCodeUsedInDTOData.DocLine = new Base.PropertyTypes.BizEntityKeyData();
                                    createBarCodeUsedInDTOData.DocLine.EntityID = rcvLine.ID;
                                    createBarCodeUsedInDTOData.DocLine.EntityType = rcvLine.Key.EntityType;
                                    createBarCodeUsedInDTOData.Item = rcvLine.ItemInfo.ItemIDKey.ID;
                                    createBarCodeUsedInDTOData.ItemCode = rcvLine.ItemInfo.ItemCode;
                                    createBarCodeUsedInDTOData.ItemName = rcvLine.ItemInfo.ItemName;
                                    createBarCodeUsedInDTOData.Org = Base.Context.LoginOrg.ID;
                                    createBarCodeUsedInDTOData.DocNo = receivement.DocNo;
                                    createBarCodeUsedInDTOData.DocLineNo = rcvLine.DocLineNo.ToString();
                                    createBarCodeUsedInDTOData.DocOrg = receivement.OrgKey.ID;
                                    ISV.Mobile.Common.CreatedDocDTOData createdDocDTOData2 = dictionary[receivement.ID];
                                    createdDocDTOData2.DocNo = receivement.DocNo;
                                    createdDocDTOData2.DocID = receivement.ID;
                                    if (createdDocDTOData2.Lines == null)
                                    {
                                        createdDocDTOData2.Lines = new List<ISV.Mobile.Common.CreatedLineDTOData>();
                                    }
                                    ISV.Mobile.Common.CreatedLineDTOData createdLineDTOData = new ISV.Mobile.Common.CreatedLineDTOData();
                                    createdDocDTOData2.Lines.Add(createdLineDTOData);
                                    createdLineDTOData.DocLineID = rcvLine.ID;
                                    createdLineDTOData.DocLineNo = rcvLine.DocLineNo;
                                    createdLineDTOData.BarCodeList = new List<ISV.Mobile.Common.ItemBarCodelineUseDTOData>();
                                    ISV.Mobile.Common.ItemBarCodelineUseDTOData itemBarCodelineUseDTOData = new ISV.Mobile.Common.ItemBarCodelineUseDTOData();
                                    createdLineDTOData.BarCodeList.Add(itemBarCodelineUseDTOData);
                                    itemBarCodelineUseDTOData.BarCode = potoRcvBCDTOData.BarCode;
                                    itemBarCodelineUseDTOData.Qty = potoRcvBCDTOData.SrcDocDetails[0].Qty;
                                }
                            }
                        }
                    }
                }
            }
            Dictionary<long, ISV.Mobile.Common.CreatedDocDTOData> dictionary2 = new Dictionary<long, ISV.Mobile.Common.CreatedDocDTOData>();
            Dictionary<long, List<UFSoft.UBF.Business.BusinessEntity.EntityKey>> dictionary3 = new Dictionary<long, List<UFSoft.UBF.Business.BusinessEntity.EntityKey>>();
            if (srcdocbarcodes[0].IsCreateItemCode)
            {
                foreach (PM.Rcv.Receivement receivement in entityList)
                {
                    long num = receivement.OrgKey.ID;
                    foreach (PM.Rcv.RcvLine rcvLine in receivement.RcvLines)
                    {
                        if (!dictionary3.ContainsKey(num))
                        {
                            dictionary3.Add(num, new List<UFSoft.UBF.Business.BusinessEntity.EntityKey>());
                        }
                        dictionary3[num].Add(rcvLine.Key);
                        dictionary2.Add(rcvLine.Key.ID, dictionary[receivement.ID]);
                    }
                }
            }
            if (list2.Count > 0)
            {
                new BC.CalcData.Proxy.CreateBarCodeUsedSVProxy
                {
                    CreateBCUsedInParams = list2,
                    App = 9
                }.Do();
            }
            if (dictionary2.Keys.Count > 0)
            {
                foreach (long num in dictionary3.Keys)
                {
                    BC.CalcData.Proxy.CreateBarCodeSVProxy createBarCodeSVProxy = new BC.CalcData.Proxy.CreateBarCodeSVProxy();
                    createBarCodeSVProxy.CreateEntityKeys = dictionary3[num];
                    createBarCodeSVProxy.IsCreateItemBarCode = true;
                    createBarCodeSVProxy.Org = num;
                    BC.BaseData.BarCodeRule barCodeRule = BC.BaseData.BarCodeRule.Finder.Find("BarCodeEntityFullName = @fullname and BarCodeCategory=@type and Org=@org order by CreatedOn desc", new UFSoft.UBF.PL.OqlParam[]
                    {
                        new UFSoft.UBF.PL.OqlParam("fullname", PM.Rcv.RcvLine.EntityRes.BE_FullName),
                        new UFSoft.UBF.PL.OqlParam("type", BC.Common.BarCodeCategoryEnum.Item.Value),
                        new UFSoft.UBF.PL.OqlParam("org", Base.Context.LoginOrg.ID)
                    });
                    if (barCodeRule != null)
                    {
                        createBarCodeSVProxy.BarCodeRuleCode = barCodeRule.Code;
                    }
                    List<BC.CalcData.BarCodeInfoDTOData> list3 = createBarCodeSVProxy.Do();
                    if (list3 != null)
                    {
                        foreach (BC.CalcData.BarCodeInfoDTOData barCodeInfoDTOData in list3)
                        {
                            ISV.Mobile.Common.ItemBarCodelineUseDTOData itemBarCodelineUseDTOData2 = new ISV.Mobile.Common.ItemBarCodelineUseDTOData();
                            itemBarCodelineUseDTOData2.BarCode = barCodeInfoDTOData.BarCode;
                            itemBarCodelineUseDTOData2.Qty = barCodeInfoDTOData.WhQty;
                            foreach (BC.CalcData.BarCodeInfoDetailDTOData barCodeInfoDetailDTOData in barCodeInfoDTOData.BarCodeInfoDetailDTO)
                            {
                                if (barCodeInfoDetailDTOData.DimensionType == BC.Common.DimensionTypeEnum.ItemCode.Value)
                                {
                                    itemBarCodelineUseDTOData2.ItemCode = barCodeInfoDetailDTOData.SegmentValue;
                                }
                                else if (barCodeInfoDetailDTOData.DimensionType == BC.Common.DimensionTypeEnum.ItemName.Value)
                                {
                                    itemBarCodelineUseDTOData2.ItemName = barCodeInfoDetailDTOData.SegmentValue;
                                }
                                else if (barCodeInfoDetailDTOData.DimensionType == BC.Common.DimensionTypeEnum.ItemSPECS.Value)
                                {
                                    itemBarCodelineUseDTOData2.ItemSpecs = barCodeInfoDetailDTOData.SegmentValue;
                                }
                                else if (barCodeInfoDetailDTOData.DimensionType == BC.Common.DimensionTypeEnum.Lot.Value)
                                {
                                    itemBarCodelineUseDTOData2.LotCode = barCodeInfoDetailDTOData.DimensionName;
                                }
                            }
                            ISV.Mobile.Common.CreatedDocDTOData createdDocDTOData3 = dictionary2[barCodeInfoDTOData.CreateEntity.ID];
                            if (createdDocDTOData3.ItemBarCodes == null)
                            {
                                createdDocDTOData3.ItemBarCodes = new List<ISV.Mobile.Common.ItemBarCodelineUseDTOData>();
                            }
                            createdDocDTOData3.ItemBarCodes.Add(itemBarCodelineUseDTOData2);
                        }
                    }
                }
            }
            return list;
        }
    }

	#endregion
	
	
}