﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UFSoft.UBF.Business;
using UFSoft.UBF.PL.Engine.Cache;

namespace UFIDA.U9.Cust.KuSi.zhangky.BPSVPlug.ApproveRcvRptDocSV
{
    public partial class ApproveRcvRptDocSVPlug : UFSoft.UBF.Service.BPSVExtendBase
    {
        public override void AfterDo(object bp, ref object result)
        {
            #region 获取相关强类型数据                               
            //成品确认入库(入库+出库都用这个应用)
            UFIDA.U9.BC.ApproveDocSV.ApproveRcvRptDocSV strongBP = bp as UFIDA.U9.BC.ApproveDocSV.ApproveRcvRptDocSV;
            if (strongBP == null)
                return;
            PLCacheManager.DataCache.FlushCache();
            PLCacheManager.ObjectCache.FlushCache();
            using (ISession session = Session.Open())
            {
                foreach (BC.ApproveDocSV.RcvRptDocDTOData rcvRptDocDTOData in strongBP.ParamInList)
                {
                    foreach (var needChangePUQtyDTOData in rcvRptDocDTOData.Lines)
                    {
                        long whid = 0;
                        string whcode = "";
                        string whname = "";
                        long binid = 0;
                        string bincode = "";
                        string binname = "";
                        UFIDA.U9.Complete.RCVRpt.RcvRptDocLine rcvRptDocLine = UFIDA.U9.Complete.RCVRpt.RcvRptDocLine.Finder.FindByID(needChangePUQtyDTOData.LineID);
                        if (rcvRptDocLine != null)
                        {
                            if (rcvRptDocLine.Wh != null)
                            {
                                whid = rcvRptDocLine.Wh.ID;
                                whcode = rcvRptDocLine.Wh.Code;
                                whname = rcvRptDocLine.Wh.Name;
                            }
                            if (rcvRptDocLine.Bin != null)
                            {
                                binid = rcvRptDocLine.Bin.ID;
                                bincode = rcvRptDocLine.Bin.Code;
                                binname = rcvRptDocLine.Bin.Name;
                            }

                        }
                        if (rcvRptDocLine.RcvRptDoc.Direction.Value == MO.Enums.CompleteRptDirectionEnum.WhShipment.Value)
                        {
                            ClearBinWhNew.Clear(needChangePUQtyDTOData.LineID, "UFIDA.U9.Complete.RCVRpt.RcvRptDocLine", "");

                        }
                        else if (rcvRptDocLine.RcvRptDoc.Direction.Value == MO.Enums.CompleteRptDirectionEnum.WhRcv.Value)
                        {
                            UpdateBarCodeNew.Update(needChangePUQtyDTOData.LineID, "UFIDA.U9.Complete.RCVRpt.RcvRptDocLine", "", binid, bincode, binname, whid, whcode, whname);
                        }
                    }
                }
                session.Commit();
            }
            #endregion

        }

        public override void BeforeDo(object bp)
        {

        }
    }
}
