﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UFSoft.UBF.Business;
using UFSoft.UBF.PL.Engine.Cache;

namespace UFIDA.U9.Cust.KuSi.zhangky.BPSVPlug
{
    internal class ClearBinWh
    {
        public static void Clear(long id, string entityType, string barcode)
        {
            using (ISession session = Session.Open())
            {
                string strTmp ;

                if (string.IsNullOrEmpty(barcode))
                {
                    strTmp = "UseDocLine.EntityID=@ID and UseDocLine.EntityType=@EntityType order by CreatedOn desc";
                }
                else
                {
                    strTmp = "UseDocLine.EntityID=@ID and UseDocLine.EntityType=@EntityType and BarCode='" + barcode + "' order by CreatedOn desc";
                }

                if (entityType.Contains("TransferFormL")|| entityType.Contains("TransferFormSL")) 
                {
                    strTmp=strTmp.Replace("UseDocLine", "CreateEntity");
                }
                PLCacheManager.DataCache.FlushCache();
                PLCacheManager.ObjectCache.FlushCache();
                UFIDA.U9.BC.BaseData.BarCodeUsed.EntityList tmp = UFIDA.U9.BC.BaseData.BarCodeUsed.Finder.FindAll(strTmp
                    , new UFSoft.UBF.PL.OqlParam[]
                    {
                    new UFSoft.UBF.PL.OqlParam(id),
                    new UFSoft.UBF.PL.OqlParam(entityType)
                    });
                if (tmp != null && tmp.Count > 0)
                {
                    List<UFIDA.U9.BC.BaseData.BarCodeUsed> list = Distinct(tmp);
                    foreach (var barCodeUsed in list)
                    {
                        barCodeUsed.SetValue("Cust4Binid", null);
                        barCodeUsed.SetValue("Cust4Bincode", null);
                        barCodeUsed.SetValue("Cust4Binname", null);
                        barCodeUsed.BarCodeMaster.SetValue("Cust4Binid", null);
                        barCodeUsed.BarCodeMaster.SetValue("Cust4Bincode", null);
                        barCodeUsed.BarCodeMaster.SetValue("Cust4Binname", null);
                        barCodeUsed.SetValue("Cust4Whid", null);
                        barCodeUsed.SetValue("Cust4Whcode", null);
                        barCodeUsed.SetValue("Cust4Whname", null);
                        barCodeUsed.BarCodeMaster.SetValue("Cust4Whid", null);
                        barCodeUsed.BarCodeMaster.SetValue("Cust4Whcode", null);
                        barCodeUsed.BarCodeMaster.SetValue("Cust4Whname", null);
                    }
                }
                session.Commit();
                
            }
        }

        private static List<UFIDA.U9.BC.BaseData.BarCodeUsed> Distinct(UFIDA.U9.BC.BaseData.BarCodeUsed.EntityList list)
        {
            Dictionary<string, UFIDA.U9.BC.BaseData.BarCodeUsed> dic = new Dictionary<string, UFIDA.U9.BC.BaseData.BarCodeUsed>();
            foreach (var barCodeUsed in list)
            {
                if (!dic.ContainsKey(barCodeUsed.BarCode))
                {
                    dic.Add(barCodeUsed.BarCode, barCodeUsed);
                }
            }

            return new List<UFIDA.U9.BC.BaseData.BarCodeUsed>(dic.Values);
        }
    }
}
