﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UFIDA.U9.BC.BaseData;
using UFIDA.U9.CBO.SCM.Warehouse;
using UFSoft.UBF.Business;
using UFSoft.UBF.PL;
using UFSoft.UBF.PL.Engine.Cache;

namespace UFIDA.U9.Cust.KuSi.zhangky.BPSVPlug.CreateDocByQuickTransIn
{
    public partial class CreateDocByQuickTransInPlug : UFSoft.UBF.Service.BPSVExtendBase
    {
        private Dictionary<string, BinWhMsg> dictionary;

        public override void AfterDo(object bp, ref object result)
        {
            //货位整理
            #region 获取相关强类型数据                               

            int TransferInType = 0;//一步式或者二步式
            //Hashtable hashtable = new Hashtable();

            UFIDA.U9.BC.QuickTransIn.CreateDocByQuickTransIn strongBP = bp as UFIDA.U9.BC.QuickTransIn.CreateDocByQuickTransIn;
            if (strongBP == null)
                return;

            foreach (var createDocParamDTOData in strongBP.ParamInList)
            {
                if (createDocParamDTOData.TransferInType == 0)//一步式，直接生成调入单，插入库位 
                {
                    TransferInType = 0;
                }
                else if (createDocParamDTOData.TransferInType == 1) //二步式，生成的是调出单，删除库位 
                {
                    TransferInType = 1;
                }
                else 
                {
                    TransferInType = 2;//无效类型
                }
            }

            List<UFIDA.U9.BC.QuickTransIn.RtnDTOData> rtnDTODatas = result as List<UFIDA.U9.BC.QuickTransIn.RtnDTOData>;
            if (rtnDTODatas == null) 
            {
                return;
            }
            PLCacheManager.DataCache.FlushCache();
            PLCacheManager.ObjectCache.FlushCache();
            using (ISession session = Session.Open())
            {
                foreach (var rtnDTOData in rtnDTODatas)
                {
                    if (TransferInType == 0)
                    {
                        UFIDA.U9.InvDoc.TransferIn.TransInLine transInLine = UFIDA.U9.InvDoc.TransferIn.TransInLine.Finder.FindByID(rtnDTOData.DocLineID);
                        if (transInLine == null || transInLine.TransInWh == null)
                        {
                            continue;
                        }
                        if (dictionary.ContainsKey(rtnDTOData.BarCode))
                        {
                            BinWhMsg binWhMsg = dictionary[rtnDTOData.BarCode];
                            UpdateBarCodeNew.Update(rtnDTOData.DocLineID, "UFIDA.U9.InvDoc.TransferIn.TransInLine", "", binWhMsg.binid, binWhMsg.bincode, binWhMsg.binname, transInLine.TransInWh.ID, transInLine.TransInWh.Code, transInLine.TransInWh.Name);
                        }
                    }
                    else if (TransferInType == 1)
                    {
                        ClearBinWhNew.Clear(rtnDTOData.DocLineID, "UFIDA.U9.InvDoc.TransferOut.TransOutLine", rtnDTOData.BarCode);
                    }
                }
                session.Commit();
            }
            
            #endregion

        }

        public override void BeforeDo(object bp)
        {
            dictionary = new Dictionary<string, BinWhMsg>();
            BC.QuickTransIn.CreateDocByQuickTransIn bpObj = (BC.QuickTransIn.CreateDocByQuickTransIn)bp;
            foreach (var paramDTO in bpObj.ParamInList)
            {
                Warehouse outWh = Warehouse.Finder.FindByID(paramDTO.OutWh);
                if (outWh != null)
                {
                    foreach (var docDTO in paramDTO.Datas)
                    {
                        foreach (var barCodeDTO in docDTO.BarCodes)
                        {
                            BarCode barCode = BarCode.Finder.Find("Code=@Code",
                                new OqlParam[]
                                {
                                    new OqlParam(barCodeDTO.BarCode)
                                });
                            if (barCode != null)
                            {
                                if (barCode["Cust4Whid"] == null)
                                {
                                    throw new Exception(string.Format("条码{0}当前存储地点为空，不允许进行调拨", barCode.Code));
                                }
                                Warehouse currentWh = Warehouse.Finder.FindByID(barCode["Cust4Whid"]);
                                if (currentWh == null)
                                {
                                    throw new Exception(string.Format("条码{0}当前存储地点为空，不允许进行调拨", barCode.Code));
                                }
                                if (outWh.ID != currentWh.ID)
                                {
                                    throw new Exception(string.Format("调出存储地点{0}与条码{1}当前存储地点{2}不一致，不允许进行调拨", outWh.Name, barCode.Code, currentWh.Name));
                                }
                                if (outWh.IsBin)
                                {
                                    if (barCode["Cust4Binid"] != null)
                                    {
                                        UFIDA.U9.CBO.SCM.Bin.Bin currentBin = UFIDA.U9.CBO.SCM.Bin.Bin.Finder.FindByID(barCode["Cust4Binid"]);
                                        if (currentBin != null)
                                        {
                                            UFIDA.U9.CBO.SCM.Bin.Bin bin = UFIDA.U9.CBO.SCM.Bin.Bin.Finder.FindByID(barCodeDTO.TrasnOutBin);
                                            if (bin == null)
                                            {
                                                throw new Exception("调出库位不能为空，库位ID为：" + barCodeDTO.TrasnOutBin.ToString());
                                            }
                                            if (bin.ID != currentBin.ID)
                                            {
                                                throw new Exception(string.Format("调出库位{0}与条码{1}当前库位{2}不一致，不允许进行调拨", bin.Name, barCode.Code, currentBin.Name));
                                            }
                                        }
                                        else 
                                        {
                                            throw new Exception(string.Format("当前库位ID不存在{0}", barCode["Cust4Binid"].ToString()));
                                        }
                                    }
                                    else 
                                    {
                                        throw new Exception(string.Format("已启用库位管理，当前库位不能为空"));
                                    }
                                }
                                
                                UFIDA.U9.CBO.SCM.Bin.Bin binIn = UFIDA.U9.CBO.SCM.Bin.Bin.Finder.FindByID(barCodeDTO.TransInBin);
                                long binid = 0;
                                string bincode = "";
                                string binname = "";
                                if (binIn != null)
                                {
                                    binid = binIn.ID;
                                    bincode = binIn.Code;
                                    binname = binIn.Name;
                                }
                                BinWhMsg binWhMsg = new BinWhMsg();
                                binWhMsg.binid = binid;
                                binWhMsg.bincode = bincode;
                                binWhMsg.binname = binname;
                                if (!dictionary.ContainsKey(barCodeDTO.BarCode))
                                {
                                    dictionary.Add(barCodeDTO.BarCode, binWhMsg);
                                }
                            }
                        }
                    }
                }
                else
                {
                    throw new Exception("调出仓库不能为空");
                }
            }
        }

        class BinWhMsg
        {
            public long binid { get; set; }
            public string bincode { get; set; }
            public string binname { get; set; }
        }
    }
}
