﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UFIDA.U9.BC.CreateTransInByTransOut;
using UFSoft.UBF.Business;
using UFSoft.UBF.PL.Engine.Cache;

namespace UFIDA.U9.Cust.KuSi.zhangky.BPSVPlug.CreateTransInByTransOut
{
    public partial class CreateTransInByTransOutPlug : UFSoft.UBF.Service.BPSVExtendBase
    {
        public override void AfterDo(object bp, ref object result)
        {
            //依调出单调入  
            #region 获取相关强类型数据                               

            UFIDA.U9.Cust.KS.TH.CreateTransInByTransOut.CreateTransInByTransOut strongBP = bp as UFIDA.U9.Cust.KS.TH.CreateTransInByTransOut.CreateTransInByTransOut;
            if (strongBP == null)
                return;

            UFIDA.U9.Cust.KS.TH.CreateTransInByTransOut.TransInResultDTOData transInResultDTOData = result as UFIDA.U9.Cust.KS.TH.CreateTransInByTransOut.TransInResultDTOData;
            if (transInResultDTOData == null) 
            {
                return;
            }

            UFIDA.U9.InvDoc.TransferIn.TransferIn transferIn = UFIDA.U9.InvDoc.TransferIn.TransferIn.Finder.FindByID(transInResultDTOData.TransInID);
            if (transferIn != null) 
            {
                PLCacheManager.DataCache.FlushCache();
                PLCacheManager.ObjectCache.FlushCache();
                using (ISession session = Session.Open())
                {
                    foreach (var transInLine in transferIn.TransInLines)
                    {
                        foreach (var transOutSubLineDTOData in strongBP.ParamInList)
                        {
                            if (transInLine.SrcDocInfo.SrcDocSubLine.EntityID == transOutSubLineDTOData.DocSubLine)
                            {
                                foreach (var barcodeInfo in transOutSubLineDTOData.BarCodeList)
                                {
                                    UFIDA.U9.CBO.SCM.Bin.Bin bin = UFIDA.U9.CBO.SCM.Bin.Bin.Finder.FindByID(barcodeInfo.Bin);
                                    if (bin == null)
                                    {
                                        UpdateBarCodeNew.Update(transInLine.ID, "UFIDA.U9.InvDoc.TransferIn.TransInLine", barcodeInfo.BarCode, 0, "", "", transInLine.TransInWh.ID, transInLine.TransInWh.Code, transInLine.TransInWh.Name);
                                    }
                                    else 
                                    {
                                        UpdateBarCodeNew.Update(transInLine.ID, "UFIDA.U9.InvDoc.TransferIn.TransInLine", barcodeInfo.BarCode, bin.ID, bin.Code, bin.Name, transInLine.TransInWh.ID, transInLine.TransInWh.Code, transInLine.TransInWh.Name);
                                    }
                                }
                            }
                        }
                    }
                    session.Commit();
                }
            }
            #endregion
        }

        public override void BeforeDo(object bp)
        {

        }
    }
}
