﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UFIDA.U9.BC.CalcData.Proxy;
using UFSoft.UBF.Business;

namespace UFIDA.U9.Cust.Kusi.CJJ.Plugin.BE.TransferForm
{
    public class UpdateBarCode : UFSoft.UBF.Eventing.IEventSubscriber
    {
        public void Notify(params object[] args)
        {
            #region 从事件参数中取得当前业务实体													 

            if (args == null || args.Length == 0 || !(args[0] is UFSoft.UBF.Business.EntityEvent))
                return;
            BusinessEntity.EntityKey key = ((UFSoft.UBF.Business.EntityEvent)args[0]).EntityKey;
            if (key == null)
                return;
            UFIDA.U9.InvDoc.TransferForm.TransferForm holder = key.GetEntity() as UFIDA.U9.InvDoc.TransferForm.TransferForm;
            if (holder == null)
                return;

            #endregion
            //弃审时更新条码库位存储信息
            if (holder.Status == UFIDA.U9.InvDoc.Enums.INVDocStatus.Open
                && holder.OriginalData != null
                && holder.OriginalData.Status == UFIDA.U9.InvDoc.Enums.INVDocStatus.Approved)
            {
                foreach (var line in holder.TransferFormLs)
                {
                    #region 形态转换单弃审时，条码转换后，删除条码使用档和主档。
                    using (ISession session = Session.Open())
                    {
                        UFIDA.U9.BC.BaseData.BarCodeUsed.EntityList tmp = UFIDA.U9.BC.BaseData.BarCodeUsed.Finder.FindAll("CreateEntity.EntityID=@ID and CreateEntity.EntityType=@EntityType and CurQty>0 order by CreatedOn desc"
                            , new UFSoft.UBF.PL.OqlParam[]
                            {
                                new UFSoft.UBF.PL.OqlParam(line.ID),
                                new UFSoft.UBF.PL.OqlParam("UFIDA.U9.InvDoc.TransferForm.TransferFormL")
                            });
                        if (tmp != null && tmp.Count > 0)
                        {
                            List<UFIDA.U9.BC.BaseData.BarCodeUsed> list = BarCodeUpdater.Distinct(tmp);
                            foreach (var barCodeUsed in list)
                            {
                                List<string> listBarcode = new List<string>();
                                listBarcode.Add(barCodeUsed.BarCode);
                                new BarCodeInvalidSVProxy
                                {
                                    BarCode = listBarcode,
                                    Org = Convert.ToInt64(UFIDA.U9.Base.Context.LoginOrg.ID)
                                }.Do();
                                barCodeUsed.BarCodeMaster.Remove();
                                barCodeUsed.Remove();
                            }
                        }
                        session.Commit();
                    }
                    #endregion

                    foreach (var subline in line.TransferFormSLs)
                    {
                        #region 形态转换单弃审时，条码转换前，更新主档现存量，删除条码使用档。
                        using (ISession session = Session.Open())
                        {
                            UFIDA.U9.BC.BaseData.BarCodeUsed.EntityList tmp = UFIDA.U9.BC.BaseData.BarCodeUsed.Finder.FindAll("CreateEntity.EntityID=@ID and CreateEntity.EntityType=@EntityType and CurQty>0 order by CreatedOn desc"
                                , new UFSoft.UBF.PL.OqlParam[]
                                {
                                new UFSoft.UBF.PL.OqlParam(subline.ID),
                                new UFSoft.UBF.PL.OqlParam("UFIDA.U9.InvDoc.TransferForm.TransferFormSL")
                                });
                            if (tmp != null && tmp.Count > 0)
                            {
                                List<UFIDA.U9.BC.BaseData.BarCodeUsed> list = BarCodeUpdater.Distinct(tmp);
                                foreach (var barCodeUsed in list)
                                {
                                    if (barCodeUsed.IsUpdateWh)
                                    {
                                        string barCodeTmp = barCodeUsed.BarCode;
                                        UFIDA.U9.BC.Common.DirectEnum directEnum = barCodeUsed.Direct;
                                        decimal qty = barCodeUsed.CurQty;
                                        barCodeUsed.Remove();
                                        session.Commit();
                                        var barCodeUsedTmp = UFIDA.U9.BC.BaseData.BarCodeUsed.Finder.Find(string.Format("BarCode='{0}' order by CreatedOn desc", barCodeTmp));
                                        string binid = "";
                                        string bincode = "";
                                        string binname = "";
                                        string whid = "";
                                        string whcode = "";
                                        string whname = "";
                                        if (barCodeUsedTmp != null)
                                        {
                                            binid = barCodeUsedTmp["Cust4Binid"].ToString();
                                            bincode = barCodeUsedTmp["Cust4Bincode"].ToString();
                                            binname = barCodeUsedTmp["Cust4Binname"].ToString();
                                            whid = barCodeUsedTmp["Cust4Whid"].ToString();
                                            whcode = barCodeUsedTmp["Cust4Whcode"].ToString();
                                            whname = barCodeUsedTmp["Cust4Whname"].ToString();
                                        }
                                        else 
                                        {
                                            barCodeUsedTmp = barCodeUsed;
                                        }
                                        barCodeUsedTmp.BarCodeMaster.WhQty = barCodeUsedTmp.BarCodeMaster.WhQty + qty;
                                        barCodeUsedTmp.BarCodeMaster.SetValue("Cust4Binid", binid);
                                        barCodeUsedTmp.BarCodeMaster.SetValue("Cust4Bincode", bincode);
                                        barCodeUsedTmp.BarCodeMaster.SetValue("Cust4Binname", binname);
                                        barCodeUsedTmp.BarCodeMaster.SetValue("Cust4Whcode", whcode);
                                        barCodeUsedTmp.BarCodeMaster.SetValue("Cust4Whname", whname);
                                        barCodeUsedTmp.BarCodeMaster.SetValue("Cust4Whid", whid);
                                    }
                                }
                            }
                            session.Commit();
                        }
                        #endregion
                    }
                }
            }


            //提交前的保存时出入库单据审核控制条码仓
            if (holder.Status == UFIDA.U9.InvDoc.Enums.INVDocStatus.Open
                && holder.OriginalData != null
                && holder.OriginalData.Status == UFIDA.U9.InvDoc.Enums.INVDocStatus.Open) 
            {
                foreach (var line in holder.TransferFormLs)
                {
                    if (line.Wh != null)
                    {
                        if (line.Wh.DescFlexField.PrivateDescSeg1.ToUpper().Equals("TRUE") && !Base.Context.LoginUser.Contains("PDA"))
                        {
                            throw new Exception(string.Format("单号{0}，{1}行的存储地点为条码管理，请扫码出货。", holder.DocNo, line.DocLineNo));
                        }
                    }
                    foreach (var subline in line.TransferFormSLs)
                    {
                        if (subline.Wh != null)
                        {
                            if (subline.Wh.DescFlexField.PrivateDescSeg1.ToUpper().Equals("TRUE") && !Base.Context.LoginUser.Contains("PDA"))
                            {
                                throw new Exception(string.Format("单号{0}，{1}行的存储地点为条码管理，请扫码出货。", holder.DocNo, line.DocLineNo));
                            }
                        }
                    }
                }
            }

        }
    }
}
