﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UFSoft.UBF.Business;

namespace UFIDA.U9.Cust.Kusi.CJJ.Plugin.BE.TransferOut
{
    public class DocCheck : UFSoft.UBF.Eventing.IEventSubscriber
    {
        public void Notify(params object[] args)
        {
            #region 从事件参数中取得当前业务实体													 

            if (args == null || args.Length == 0 || !(args[0] is UFSoft.UBF.Business.EntityEvent))
                return;
            BusinessEntity.EntityKey key = ((UFSoft.UBF.Business.EntityEvent)args[0]).EntityKey;
            if (key == null)
                return;
            UFIDA.U9.InvDoc.TransferOut.TransferOut holder = key.GetEntity() as UFIDA.U9.InvDoc.TransferOut.TransferOut;
            if (holder == null)
                return;

            #endregion

            foreach (var line in holder.TransOutLines)
            {
                if (line.TransOutWh != null)
                {
                    if (line.TransOutWh.DescFlexField.PrivateDescSeg1.ToUpper().Equals("TRUE") && !Base.Context.LoginUser.Contains("PDA"))
                    {
                        throw new Exception(string.Format("单号{0}，{1}行的存储地点为条码管理，请扫码出货。", holder.DocNo, line.DocLineNo));
                    }
                }
            }

        }
    }
}
